
	var controlAppID   = 'fjhkbefkgmlohmnnecccmahjbfjpoool';
	var serverSocketId = false;
	var _sockets = {};
	chrome.app.window.create('background.html',{id:'main',bounds:{width:620,height:500}});
	chrome.sockets.tcpServer.create({},function(createInfo){
		chrome.sockets.tcpServer.listen(createInfo.socketId,'127.0.0.1',2000,function(result){
			if( result < 0 ){console.log('Error listening:' + chrome.runtime.lastError.message);return false;}
			serverSocketId = createInfo.socketId;

			/* INI-Envio de mensajes al cliente
			 * Si recibimos un mensaje lo transmitimos directamente al socket */
			chrome.runtime.onMessageExternal.addListener(function(request,sender,sendResponse){
				var message = JSON.parse(request);

				chrome.sockets.tcp.getInfo(message.clientSocketId,function(socketInfo){
					if( !socketInfo['connected'] ){
						chrome.runtime.sendMessage(controlAppID,{'command':'exit','client':message.clientSocketId},function(response){});
						return false;
					}

					var buf = str2ab(request + '\r\n');
					chrome.sockets.tcp.send(message.clientSocketId,buf,function(resultCode){
						if( chrome.runtime.lastError ){
							chrome.runtime.sendMessage(controlAppID,{'command':'exit','client':message.clientSocketId},function(response){});
							//chrome.runtime.sendMessage(serverAppID,JSON.stringify({'clientSocketId':request.clientSocketId,'errorDescription':'UNKNOWN_ERROR'}),function(response){});
							return false;
						}
						//console.log("Data sent: "+JSON.stringify(resultCode));
					});
				});
			});
			/* END-Envio de mensajes al cliente */

			chrome.sockets.tcpServer.onAccept.addListener(function(recvInfo){
				table.update(recvInfo);

				if( recvInfo.socketId != serverSocketId ){
					console.log("No coincide: "+recvInfo.socketId+' '+serverSocketId);
					return false;
				}


				var buf = str2ab('Welcome!' + '\r\n');
				// A new TCP connection has been established.
				chrome.sockets.tcp.send(recvInfo.clientSocketId,buf,function(resultCode){
					if( chrome.runtime.lastError ){
						return false;
					}
					//console.log("Welcome! enviado.");
				});

				chrome.sockets.tcp.setPaused(recvInfo.clientSocketId,false);
				//chrome.sockets.tcp.setKeepAlive(recvInfo.clientSocketId,true,20,function(result){
				//console.log(result);
				//});
			});

			chrome.sockets.tcp.onReceiveError.addListener(function(recvInfo){
				recvInfo.clientSocketId = recvInfo.socketId;
				recvInfo.socketId = serverSocketId;
				chrome.sockets.tcp.getInfo(recvInfo.clientSocketId,function(socketInfo){
					if( chrome.runtime.lastError ){
						return false;
					}

					chrome.runtime.sendMessage(controlAppID,{'command':'exit','client':recvInfo.clientSocketId},function(response){});
					chrome.sockets.tcp.close(recvInfo.clientSocketId,function(){
						if( chrome.runtime.lastError ){
							return false;
						}
					});
				});


				//console.log(recvInfo);
				table.remove(recvInfo);
			});

			// Start receiving data.
			chrome.sockets.tcp.onReceive.addListener(function(recvInfo){
				recvInfo.clientSocketId = recvInfo.socketId;
				recvInfo.socketId = serverSocketId;

				/* INI-Actualizamos la tabla */
				table.update(recvInfo);
				/* END-Actualizamos la tabla */

				var data = ab2str(recvInfo.data);
				data = data.trim();
				if( data === 'exit' ){
					chrome.runtime.sendMessage(controlAppID,{'command':'exit','client':recvInfo.clientSocketId},function(response){
						chrome.sockets.tcp.close(recvInfo.clientSocketId);
						table.remove(recvInfo);
					});
					return false;
				}

				var json = false;
				//console.log('Debug (' + data.length + '): '+data);
				if( !(json = $json.decode(data)) ){
					console.log('Unable to decode');
					return false;
				}
				if( json['command'] && json['command'] == 'exit' ){
					chrome.runtime.sendMessage(controlAppID,{'command':'exit','client':recvInfo.clientSocketId},function(response){
						chrome.sockets.tcp.close(recvInfo.clientSocketId,function(){
							if( chrome.runtime.lastError ){
								return false;
							}
						});
						table.remove(recvInfo);
					});
					return false;
				}
				json.clientSocketId = recvInfo.clientSocketId;
				json.client = recvInfo.clientSocketId;
				chrome.runtime.sendMessage(controlAppID,json,function(response){
					/* La respuesta vendrá siempre por mensaje directo */
				});
			});
		});
	});

	chrome.runtime.onMessage.addListener(function(request,sender,sendResponse){
		console.log(sender);
	});
	chrome.runtime.onSuspend.addListener(function(){
		var _window = chrome.app.window.get('main');
		console.log(_window.contentWindow.location.href);

		$ajax(_window.contentWindow.location.href,{},{
			'onEnd':function(){
				//keepalive();
			}
		});
	});
	chrome.runtime.onSuspendCanceled.addListener(function(){
		_window.querySelector('#debuf').innerHTML += '<div>suspend canceled</div>';
	});

	window.setInterval(function(){
		//console.log('interval');
		var a;
		chrome.sockets.tcp.getSockets(function(infos){
			for( a in infos ){
				if( !infos[a]['socketId'] ){continue;}
				if( infos[a].connected ){continue;}
				chrome.sockets.tcp.close(infos[a].socketId,function(){
					if( chrome.runtime.lastError ){
						table.remove({'socketId':serverSocketId,'clientSocketId':infos[a].socketId});
						return false;
					}
				});
				table.remove({'socketId':serverSocketId,'clientSocketId':infos[a].socketId});
			}
		});
	},2000);

	function keepalive(){
		setTimeout(function(){
			$ajax('http://localhost',{},{
				'onEnd':function(){
					keepalive();
				}
			});
		},1000);
	}
	//keepalive();

	function _table(){};
	_table.prototype.create = function(info){
		_sockets[info.clientSocketId] = info;
		_sockets[info.clientSocketId]['update'] = Date.now();

		var _window = chrome.app.window.get('main');
		_window.contentWindow.document.querySelector('#clients').innerHTML += '<tr id="client-' + info.clientSocketId + '">'
			+ '<td>' + info.clientSocketId + '</td>'
			+ '<td>' + info.socketId + '</td>'
			+ '<td>' + date(_sockets[info.clientSocketId]['update']) + '</td>'
			+ '</tr>';
	};
	_table.prototype.update = function(info){
		if( !_sockets[info.clientSocketId] ){return this.create(info);}

		_sockets[info.clientSocketId] = info;
		_sockets[info.clientSocketId]['update'] = Date.now();

		var _window = chrome.app.window.get('main');
		var update = _window.contentWindow.document.querySelector('#client-' + info.clientSocketId + ' td:last-child');
		if( update ){update.innerHTML = date(_sockets[info.clientSocketId]['update']);}
	}
	_table.prototype.remove = function(info){
		var _window = chrome.app.window.get('main');
		var row = _window.contentWindow.document.querySelector('#client-' + info.clientSocketId);
		if( row ){row.parentNode.removeChild(row);}

		delete _sockets[info.clientSocketId];
	}
	var table = new _table();

	function date(timestamp){
		return new Date(timestamp).toISOString();
	}
	function encode_utf8(s){return unescape(encodeURIComponent(s));}
	function decode_utf8(s){
		try {var r = decodeURIComponent(escape(s));} catch (err) {var r = '';}
		return r;
	}
	function ab2str(buf){
		var s = String.fromCharCode.apply(null, new Uint8Array(buf));
		return decode_utf8(s)
	}
	function str2ab(str){
		str = unescape(encodeURIComponent(str));

		var buf = new ArrayBuffer(str.length); // 2 bytes for each char
		var bufView = new Uint8Array(buf);
		for (var i=0, strLen=str.length; i<strLen; i++) {
			bufView[i] = str.charCodeAt(i);
		}
		return buf;
	}

