# Autoactualización de extensiones

## Crear archivo de actualización
Crear archivo con configuración de actualizaciones (p.e., un XML), siguiendo la estructura Omaha utilizada por Google para sus actualizaciones (http://code.google.com/p/omaha/). Puede haber varias apps en un único archivo XML.

```
<?xml version='1.0' encoding='UTF-8'?>
<gupdate xmlns='http://www.google.com/update2/response' protocol='2.0'>
	<app appid='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa'>
		<updatecheck codebase='http://myhost.com/mytestextension/extension1.crx' version='2.0' />
	</app>
	<app appid='bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb'>
		<updatecheck codebase='http://myhost.com/mytestextension/extension2.crx' version='2.0' />
	</app>
</gupdate>
```

## Indicar URL de actualización en el archivo manifest.json de la extensión
Añadir en el archivo _manifest.json_ de la extensión el atributo _update_url_, indicando la URL donde consultar la publicación de actualizaciones.

```
{
	...
	"name": "Gazelle",
	"version": "2.0",
	"update_url": "http://myhost.com/myupdates.xml",
	...
}
```

La versión indicada en el _manifest.json_ debe coincidir con la correspondiente en el XML de acutalización para que esta se detecte y se lleve a cabo.

## Comprobación de actualizaciones
Lanzar Chrome/Chromium con el parámetro _--extensions-update-frequency_, indicando la frecuencia de comprobación de actualización (en segundos). Por ejemplo, para buscar actualizaciones cada 45 segundos:

```
chrome.exe --extensions-update-frequency=45
```
