<?php
	class _chromium{
		public $ip   = '127.0.0.1';
		public $port = '8001';
		public $path = '/gazelle';
		public $fp   = false;
		public $response = false;

		function __construct( &$serverOB = false ) {
			if ( !empty($serverOB['serverIP']) ) { $this->ip = $serverOB['serverIP']; }
			if ( !empty($serverOB['serverChromiumPort']) ) { $this->port = $serverOB['serverChromiumPort']; }
			if ( !empty($serverOB['serverPath']) ) { $this->path = $serverOB['serverPath']; }
			if ( $this->ip == '127.0.0.1' ){ $this->port = 2000; }
		}

		function tabs_get($tabID = false){

			$stream = ['command'=>'chrome.tabs.get'];
			if( $tabID ){$stream['tabID'] = $tabID;}

//FIXME: arreglar favicons en formato .ico
			return $this->__command($stream);
		}
		function tab_create($props = []){
			/* $props = ['url','async','persistent','agent','lang'] */
			if( isset($props['url']) ){
				$prefix = substr($props['url'],0,4);
				if( $prefix != 'http' && $prefix != 'file' ){$props['url'] = 'http://'.$props['url'];}
			}

			$command = 'chrome.tabs.create';
			return $this->__command(['command'=>$command,'properties'=>$props]);
		}
		function tab_remove($tabID = 0){
			$command = 'chrome.tabs.remove';
			return $this->__command(['command'=>$command,'tabID'=>$tabID]);
		}
		function tab_select($tabID = 0){
			$command = 'chrome.tabs.select';
			return $this->__command(['command'=>$command,'tabID'=>$tabID]);
		}
		function tab_update($tabID = 0,$props = []){
			/* $props = ['url','async'] */
			if( isset($props['url']) ){
				if( substr($props['url'],0,4) != 'http' ){$props['url'] = 'http://'.$props['url'];}
			}

			$command = 'chrome.tabs.update';
			return $this->__command(['command'=>$command,'tabID'=>$tabID,'properties'=>$props]);
		}
		function tab_click($tabID = 0,$x = false,$y = false){
			$url = 'http://'.$this->ip.':18080'.$this->path.'/index.php';
			$opts['http']['method'] = 'POST';
			$opts['http']['content'] = http_build_query(['subcommand'=>'click','x'=>$x,'y'=>$y]);
			$opts['http']['header'] = 'content-type: application/x-www-form-urlencoded'."\r\n";

			$context = stream_context_create($opts);
			$data    = @file_get_contents($url,false,$context);
			$data    = json_decode($data,true);
			if( !$data ){
				/* Si no se puede a través de xserver, lo hacemos a través de navegador */
				$command = 'chrome.tabs.click';
				$props = ['x'=>$x,'y'=>$y];
				$r = $this->__command(['command'=>$command,'tabID'=>$tabID,'properties'=>$props]);
				//return ['errorDescription'=>'CONNECTION_REFUSED'];
			}

			do{
				usleep(500000);
				$tab = $this->tabs_get($tabID);
			}while( $tab['result']['status'] == 'loading' );
			return $tab;
		}
		function tab_recaptcha($tabID = 0,$x = false,$y = false){
			$url = 'http://'.$this->ip.':18080'.$this->path.'/index.php';
			$opts['http']['method'] = 'POST';
			$opts['http']['content'] = http_build_query(['subcommand'=>'recaptcha','x'=>$x,'y'=>$y]);
			$opts['http']['header'] = 'content-type: application/x-www-form-urlencoded'."\r\n";

			$context = stream_context_create($opts);
			$data    = file_get_contents($url,false,$context);
var_dump($data);
exit;
			$data    = json_decode($data,true);

			do{
				usleep(500000);
				$tab = $this->tabs_get($tabID);
			}while( $tab['result']['status'] == 'loading' );
			return $tab;
		}
		function tab_screenshot($tabID = 0){
			$command = 'chrome.tabs.screenshot';
			return $this->__command(['command'=>$command,'tabID'=>$tabID]);
		}
		function tab_trace($tabID = 0){
			$command = 'chrome.tabs.trace';
			return $this->__command(['command'=>$command,'tabID'=>$tabID]);
		}
		function tab_analyze($tabID = 0){
			$command = 'chrome.tabs.analyze';
			return $this->__command(['command'=>$command,'tabID'=>$tabID]);
		}
		function tab_version($tabID = 0){
			$command = 'version';
			return $this->__command(['command'=>$command]);
		}

		function bye(){
			$command = 'exit';
			$this->__command(['command'=>$command]);
			fclose($this->fp);
			return true;
		}

		function __feof(&$inicio = NULL){
			$inicio = microtime(true);
			return feof($this->fp);
		}
		function __read($timeout = 30){
			$t = time();

			$result = '';
			stream_set_blocking($this->fp,false);
			while( !feof($this->fp) ){
				$buffer = stream_socket_recvfrom($this->fp,1024);
				if( !empty($buffer) ){/* Si entra algo de buffer, reseteamos el tiempo */$t = time();}
				$result .= $buffer;
				if( mb_strpos($result,"\r\n") !== false ){break;}
				if( $timeout < (time() - $t) ){$result = '{"errorDescription":"TIMEOUT"}';/* timeout */break;}
				usleep(100000);
			}
			stream_set_blocking($this->fp,true);
			return trim($result);
		}
		function __command($data = ''){
			$timeout = 30;
			$exit = false;
			if( !empty($data['command']) && $data['command'] == 'version' ){$timeout = 3;}
			if( !empty($data['command']) && $data['command'] == 'chrome.tabs.screenshot' ){$timeout = 60;}
			if( !empty($data['command']) && $data['command'] == 'exit' ){$exit = true;}
			$data = json_encode($data);
			$CR   = "\r\n";

			$scheme = 'tcp';
			if( !$this->fp ){
				$context = stream_context_create();
				$this->fp = @stream_socket_client($scheme.'://'.$this->ip.':'.$this->port,$errno,$errstr,100,STREAM_CLIENT_CONNECT,$context);
				if( !$this->fp ){return ['errorDescription'=>'CONNECTION_REFUSED'];}
				stream_set_timeout($this->fp,3);
				$result = $this->__read($timeout);
				//FIXME: debe ser Welcome!
			}

			if( fwrite($this->fp,$data) === false ){echo 'Unable to write';return false;}
			if( $exit ){return true;}
			$result = $this->__read($timeout);
			//var_dump($result).PHP_EOL;

			if( !isset($result[0]) || ($result[0] != '{' && $result[0] != '[') ){
				echo $result;
				return false;
			}

			if( !function_exists('strings_toUTF8') ){include_once('inc.strings.php');}
			$this->response = $r = json_decode(strings_toUTF8($result),true);
			return $r;
		}
		function __websocket(){
			
		}

		function convertTo_traceOB($array = []){
			if( empty($array['result']['trace']) ){return false;}
			$isResourceLite = function($n){
				return ($n['type'] != 'main_frame' && $n['type'] != 'sub_frame');
			};
			//print_r($array);exit;

			ini_set('precision',30);
			$tmp = [];
			$lastHtmlMainNode = false;
			foreach( $array['result']['trace'] as $nodes ){
				/* Esto ocurre por ejemplo cuando el primer nodo es file://, porque no tiene
				 * cabeceras y no se registran */
				if( empty($nodes['start']) && !empty($nodes['end']) ){$nodes['start'] = $nodes['end'];}
				if( empty($nodes['start']) &&  empty($nodes['end']) ){continue;}

				foreach( $nodes['start'] as $node ){
					$responseHeader = [];
					if( isset($node['responseHeaders']) ){foreach( $node['responseHeaders'] as $head ){
						$responseHeader[strtolower($head['name'])] = $head['value'];
					}}
					$requestHeader = [];
					if( isset($node['requestHeaders']) ){foreach( $node['requestHeaders'] as $head ){
						$requestHeader[strtolower($head['name'])] = $head['value'];
					}}

					$nodeOB = [
						 'pageCurrent'=>$node['url']
						,'pageStart'=>strval($node['timeStamp'])
						,'pageCode'=>$node['statusCode']
						,'pageHeader'=>$responseHeader
						,'pageRequest'=>$requestHeader
						,'requestId'=>$node['requestId']
						,'frameId'=>$node['frameId']
						,'parentFrameId'=>$node['parentFrameId']
						,'id'=>str_replace('.','-',$node['timeStamp'])
					];
					if( isset($nodeOB['pageHeader']['content-type']) ){$nodeOB['pageContentType'] = $nodeOB['pageHeader']['content-type'];}
					if( isset($nodeOB['pageHeader']['location']) ){$nodeOB['pageNext'] = $nodeOB['pageHeader']['location'];}
					if( isset($nodeOB['pageRequest']['referer']) ){$nodeOB['pageReferer'] = $nodeOB['pageRequest']['referer'];}

					if( $isResourceLite($node) ){
						$candidates = [];
						/* Si es un recurso, recorremos los nodos cargados actualmente para buscar al padre */
						foreach( $tmp as $tm ){
							if( $tm['requestId'] > $node['requestId'] ){continue;}
							if( $tm['frameId'] != $node['frameId'] ){continue;}
							if( in_array($tm['pageCode'],[301,302]) ){continue;}
							$candidates[] = $tm;
						}
						/* Al terminar este algo quedan únicamente los elementos que han estado
						 * en la misma 'ventana' con la que el recurso ha estado relacionado,
						 * como 2 páginas no pueden estar en la misma ventana al mismo tiempo,
						 * solo nos queda ubicar temporalmente el recurso al cual pertenece */
						if( $candidates ){
							usort($candidates,function($a,$b){
								/* Aúnque esto no va a pasar nunca */
								if ( $a['requestId'] == $b['requestId'] ) {return 0;}
								return ($a['requestId'] < $b['requestId']) ? -1 : 1;
							});
							$candidateID = end($candidates);
							//$candidateID = $candidateID['pageStart'];
							//$_id = str_replace('.','-',$candidateID);
							$nodeOB['gazelle-referer'] = $candidateID['id'];
							$tmp[$candidateID['id']]['gazelle-resources'][$nodeOB['id']] = $nodeOB;
						}
						continue;
					}

					/* INI-vamos a buscar el padre
					 * (si hubiera) */
					if( $node['type'] == 'main_frame' && $lastHtmlMainNode !== false ){
						$candidates = [];
						foreach( $tmp as $tm ){
							if( $tm['requestId'] > $node['requestId'] ){continue;}
							if( $tm['frameId'] != $node['frameId'] ){continue;}
							if( $tm['parentFrameId'] != $node['parentFrameId'] ){continue;}
							$candidates[] = $tm;
						}
						if( $candidates ){
							usort($candidates,function($a,$b){
								/* Aúnque esto no va a pasar nunca */
								if ( $a['requestId'] == $b['requestId'] ) {return 0;}
								return ($a['requestId'] < $b['requestId']) ? -1 : 1;
							});

							$candidateID = end($candidates);
							$nodeOB['gazelle-referer'] = $candidateID['id'];
						}
					}
					if( $node['type'] == 'sub_frame' ){
						$candidates = [];
						foreach( $tmp as $tm ){
							if( $tm['requestId'] > $node['requestId'] ){continue;}
							if( $tm['frameId'] != $node['parentFrameId'] ){continue;}
							$candidates[] = $tm;
						}

						if( $candidates ){
							usort($candidates,function($a,$b){
								/* Aúnque esto no va a pasar nunca */
								if ( $a['requestId'] == $b['requestId'] ) {return 0;}
								return ($a['requestId'] < $b['requestId']) ? -1 : 1;
							});

							$candidateID = end($candidates);
							$nodeOB['gazelle-is-iframe'] = true;
							$nodeOB['gazelle-referer']   = $candidateID['id'];
						}
					}
					/* END-vamos a buscar el padre */

					//$_id = str_replace('.','-',$nodeOB['pageStart']);
					$lastHtmlMainNode = $nodeOB['id'];

					$tmp[$nodeOB['id']] = $nodeOB;
				}
			}

			if( !empty($array['result']['events']) ){
				/* Asignamos los eventos */
				foreach( $array['result']['events'] as $event ){
					if( $event['type'] == 'link' ){continue;}
					$candidate = false;
					foreach( $tmp as $k=>$node ){
						if( $node['pageStart'] > $event['timeStamp'] ){break;}
						$candidate = $k;
					}
					//FIXME: $node['pageCurrent'] == $event['location']; ??

					if( $event['type'] == 'alert' && !empty($tmp[$candidate]) ){
						$tmp[$candidate]['pageAlert'][] = $event['text'];
					}
					if( $event['type'] == 'confirm' && !empty($tmp[$candidate]) ){
						$tmp[$candidate]['pageConfirm'][] = $event['text'];
					}
					if( $event['type'] == 'beforeunload' && !empty($tmp[$candidate]) ){
						$tmp[$candidate]['pageBeforeUnload'][] = $event['text'];
					}
				}
			}

//print_r($tmp);exit;
			$last = end($tmp);
			if( !empty($last['pageNext']) ){
				$parts = parse_url($last['pageNext']);
				$node = [];
				if( !empty($parts['scheme']) && in_array($parts['scheme'],['market','itms','itmss','itms-apps','itms-appss']) ){
					$node['id'] = str_replace('-','.',$last['id']) + 1;
					$node['id'] = str_replace('.','-',$node['id']);
					$node['pageCurrent']     = $last['pageNext'];
					$node['pageCode']        = 200;
					$node['requestId']       = $last['requestId'] + 1;
					$node['frameId']         = 0;
					$node['parentFrameId']   = -1;
					$node['gazelle-referer'] = $last['id'];

					$tmp[$node['id']] = $node;
				}
			}

			return $tmp;
		}
		function _node_isResource($node = []){
			if( !isset($node['pageContentType']) && isset($node['pageHeader']['content-type']) ){
				$node['pageContentType'] = $node['pageHeader']['content-type'];
			}
			if( isset($node['pageCurrent']) && substr($node['pageCurrent'],0,5) == 'data:' ){
				return true;
			}
			return isset($node['pageContentType'],$node['pageReferer'],$node['pageCode'])
				 && ( $node['pageCode'] != 301 && $node['pageCode'] != 302 )
				 && ( strpos($node['pageContentType'],'text/javascript') !== false
				      || strpos($node['pageContentType'],'text/css') !== false
				      || strpos($node['pageContentType'],'image/jpeg') !== false
				      || strpos($node['pageContentType'],'image/gif') !== false
				      || strpos($node['pageContentType'],'image/png') !== false
				      || strpos($node['pageContentType'],'image/svg+xml') !== false
				      || strpos($node['pageContentType'],'image/webp') !== false
				      || strpos($node['pageContentType'],'application/javascript') !== false
				      || strpos($node['pageContentType'],'application/x-javascript') !== false
				      || strpos($node['pageContentType'],'application/font-woff') !== false
				      || strpos($node['pageContentType'],'font/woff') !== false
				      || strpos($node['pageContentType'],'font/ttf') !== false
				      || strpos($node['pageContentType'],'audio/mp3') !== false
				      || strpos($node['pageContentType'],'audio/ogg') !== false
				);
		}
	}

	class chromium_websocket{
		public $clients = [];
		public $socket  = false;
		public $file_in = './file.in';
		function task(){
			$host = 'localhost'; //host
			$port = 2001; //port
			$null = NULL; //null var

			$this->socket = socket_create(AF_INET,SOCK_STREAM,SOL_TCP);/* Create TCP/IP sream socket */
			socket_set_option($this->socket,SOL_SOCKET,SO_REUSEADDR,1);/* Reusable port */
			socket_bind($this->socket,0,$port);/* Bind socket to specified host */
			socket_listen($this->socket);/* Listen to port */
			socket_set_nonblock($this->socket);

			//create & add listning socket to the list
			$this->clients = [];
			$lastTime = time();

			//start endless loop, so that our script doesn't stop
			while( true ){
				//manage multipal connections
				$changed = $this->clients;

				if( ($socket_new = @socket_accept($this->socket)) ){
					/* Nueva conexión */
					//socket_set_nonblock($socket_new);
					$header = socket_read($socket_new,1024);
					if( !strpos($header,'Sec-WebSocket-Key') ){
						socket_close($socket_new);
						continue;
					}
					$this->handshake($header,$socket_new,$host,$port);
					//print_r($header);

					$this->clients[] = $socket_new;
					//echo 'Clients: '.count($this->clients).PHP_EOL;

					socket_getpeername($socket_new,$data_ip);
					$this->message([
						 'command'=>'version'
					],$socket_new);
//print_r($data);

					//socket_close($socket_new);
					continue;
					//FIXME: deberiamos desconectar?
				}

				if ( ($command = file_get_contents($this->file_in)) ) {
					$this->message($command,$socket_new);
					/* Una vez enviado el comando reseteamos el fichero
					 * para evitar que se envie el mismo comando todo el rato */
					file_put_contents($this->file_in,'');
				}

				//returns the socket resources in $changed array
				$r = $changed ? socket_select($changed,$null,$null,0,10) : 0;
				if( $r ){
print_r($changed);
					foreach( $changed as $change ){
						echo 'changed'.count($changed).PHP_EOL;
						while(socket_recv($change, $buf, 1024, 0) >= 1)
						{
							$received_text = $this->unmask($buf); //unmask data
print_r($received_text);
							//$tst_msg = json_decode($received_text); //JSON decode 

							continue 2; //exist this loop
						}



						@socket_recv($change,$buf,1024);
	var_dump($buf);
						if( $buf === NULL ){
							/* Client disconnected */
							if( ($found = array_search($change,$this->clients)) !== false ){unset($this->clients[$found]);}
							continue;
						}
					}
				}

				/*if( $this->clients ){
					foreach( $this->clients as $client ){
						$response = '';
						while ( ($buffer = socket_read($client, 1024)) && strlen($buffer) ) {
							$response .= $buffer;
						}
echo $response.PHP_EOL;
					}
				}*/

				/*$t = time();
				if( $t != $lastTime ){
					$rows = [
						['test'=>'test']
					];
					$rows = array_values($rows);

					$this->message([
						 'type'=>'update'
						,'data'=>$rows
					]);
					$lastTime = $t;
				}//*/
				continue;
			}

			// close the listening socket
			socket_close($this->socket);
		}
		function message($msg,$client = false){
			if( is_array($msg) ){
				$msg = $this->mask(json_encode($msg));
			}

			if( $client ){
				return @socket_write($client,$msg,strlen($msg));
			}

			foreach( $this->clients as $socket ){
				@socket_write($socket,$msg,strlen($msg));
			}
			return true;
		}
		function unmask($text){
			//Unmask incoming framed message
			$length = ord($text[1]) & 127;
			if( $length == 126 ){
				$masks = substr($text, 4, 4);
				$data = substr($text, 8);
			}
			elseif( $length == 127 ){
				$masks = substr($text, 10, 4);
				$data = substr($text, 14);
			}
			else{
				$masks = substr($text, 2, 4);
				$data = substr($text, 6);
			}
			$text = '';
			for ($i = 0; $i < strlen($data); ++$i) {
				$text .= $data[$i] ^ $masks[$i%4];
			}
			return $text;
		}
		function mask($text){
			//Encode message for transfer to client.
			$b1 = 0x80 | (0x1 & 0x0f);
			$length = strlen($text);
	
			if($length <= 125){
				$header = pack('CC', $b1, $length);
			}elseif($length > 125 && $length < 65536){
				$header = pack('CCn', $b1, 126, $length);
			}elseif($length >= 65536){
				$header = pack('CCNN', $b1, 127, $length);
			}
			return $header.$text;
		}
		function handshake($receved_header,$client_conn,$host,$port){
			//handshake new client.
			$headers = array();
			$lines   = preg_split("/\r\n/", $receved_header);
			foreach( $lines as $line ){
				$line = chop($line);
				if( preg_match('/\A(\S+): (.*)\z/',$line,$matches) ){
					$headers[$matches[1]] = $matches[2];
				}
			}

			$secKey    = $headers['Sec-WebSocket-Key'];
			$secAccept = base64_encode(pack('H*',sha1($secKey.'258EAFA5-E914-47DA-95CA-C5AB0DC85B11')));
			//hand shaking header
			$upgrade   = "HTTP/1.1 101 Web Socket Protocol Handshake\r\n" .
			"Upgrade: websocket\r\n" .
			"Connection: Upgrade\r\n" .
			"WebSocket-Origin: $host\r\n" .
			"WebSocket-Location: ws://$host:$port\r\n".
			"Sec-WebSocket-Accept:$secAccept\r\n\r\n";
			socket_write($client_conn,$upgrade,strlen($upgrade));
		}
	}
