<?php
	/* INI-mongo tables */
	$GLOBALS['api']['mongo']['tables']['gazelle.trace'] = [
		 '_id'=>'INTEGER AUTOINCREMENT'
		,'gazelleURL'=>'TEXT'
		,'gazelleHash'=>'TEXT'
		,'gazelleDomain'=>'TEXT'
		,'gazelleCountry'=>'TEXT'
		,'gazelleAgent'=>'TEXT'
		,'gazelleAgentHash'=>'TEXT'
		,'gazelleTrace'=>'TEXT'
		,'gazelleTraceTrust'=>'TEXT'
		,'gazelleTraceDomains'=>'TEXT'
		,'gazelleNodes'=>'TEXT'/* Los datos */
		,'gazelleData'=>'TEXT'/* Los datos */
		,'gazelleTrust'=>'TEXT'/* Los datos */
		,'gazelleDomains'=>'TEXT'
		,'gazelleDomainsTop'=>'TEXT'
		,'gazelleIPs'=>'TEXT'
		,'gazelleEndStamp'=>'TEXT'
		,'gazelleEndDate'=>'TEXT'
		,'gazelleEndTime'=>'TEXT'
		,'gazelleRequest'=>'TEXT'
		,'gazelleRequestStamp'=>'TEXT'
		,'gazelleRequestDate'=>'TEXT'
		,'gazelleBackend'=>'TEXT' /* 'phantom' o 'chrome' */
		,'gazelleUser'=>'TEXT'
		,'gazelleTags'=>'TEXT'
		,'gazelleFlags'=>'TEXT'
		,'z'=>'TEXT'/* Datos extra del cron, 'z' para que vayan al final */
	];
	/* END-mongo tables */
	/* INI-mongo indexes */
	$GLOBALS['api']['mongo']['indexes']['gazelle.trace'] = [
		 ['fields'=>['gazelleHash'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleHash'=>1,'gazelleEndStamp'=>1]]
		,['fields'=>['gazelleRequestDate'=>1,'gazelleFlags'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleRequestDate'=>1,'gazelleCountry'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleTags'=>1],'props'=>['background'=>true]]
		//,['fields'=>['_id'=>1,'gazelleUser'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleDomains'=>1,'_id'=>-1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleDomainsTop'=>1,'_id'=>-1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleTags'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleTags'=>1,'_id'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleCountry'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleURL'=>'text'],'props'=>['background'=>true,'name'=>'url']]
		,['fields'=>['gazelleUser'=>1,'gazelleRequestDate'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleRequestDate'=>1,'gazelleCountry'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleRequestDate'=>1,'gazelleDomainsTop'=>1],'props'=>['background'=>true]]
		,['fields'=>['gazelleUser'=>1,'gazelleTraceTrust.portals'=>1],'props'=>['sparse'=>true,'background'=>true]]
		,['fields'=>['gazelleTraceTrust.trace.trustStatus'=>1]]
	];
	/* END-mongo indexes */
	/* INI-trace */
	class _gazelle_trace_TB extends _mongo{
		use _url;
		use _gazelle_trace_nodes;
		public $db = 'gazelle';
		public $table = 'gazelle.trace';
		public $search_fields = ['gazelleURL'];
		public $_domain_trust = false;
		public $_gazelle_request_TB = false;
		public $_gazelle_trace_utils = false;
		public $_gazelle_trace_count_cache = false;
		function validate(&$data = [],&$oldData = []){
			include_once('inc.strings.php');
			$data['gazelleDomains'] = [];
			if( !isset($data['gazelleAgent']) ){return ['errorDescription'=>'INVALID_TRACE','file'=>__FILE__,'line'=>__LINE__];}
			if( !isset($data['gazelleRequestDate']) && isset($data['gazelleRequestStamp']) ){$data['gazelleRequestDate'] = date('Y-m-d',$data['gazelleRequestStamp']);}
			if( !isset($data['gazelleTags']) ){$data['gazelleTags'] = ['unread','inbox'];}
			$data['gazelleFlags'] = [];
			$data['gazelleAgentHash'] = md5($data['gazelleAgent']);

			/* INI-Detectamos si ha fallado virustotal */
			if( !empty($data['gazelleTrust']) ){foreach( $data['gazelleTrust'] as $trust ){
				if( isset($trust['_virustotal']['errorDescription'])
				 || empty($trust['_virustotal']['page']) ){
					$data['gazelleFlags'][] = 'trust-virustotal';
				}
			}}
			/* END-Detectamos si ha fallado virustotal */

			/* INI-Validamos los datos */
			if( isset($data['gazelleTrace']) ){
				$this->_validate_trace($data['gazelleTrace']);
				foreach( $data['gazelleTrace'] as &$node ){
					if( empty($node['pageCode']) ){continue;}

					if( strpos($node['pageCurrent'],'chrome-extension:') === 0 ){
						$data['gazelleTags'][] = 'chrome-extension-check';
					}
					if( strpos($node['pageCurrent'],'sms:') === 0 ){
						$data['gazelleTags'][] = 'sms';
					}

					if( !empty($node['pageCurrent'])
					 && strpos($node['pageCurrent'],'market:') === 0
					 && !empty($node['pageStageError']) ){unset($node['pageStageError']);}

					if( !isset($node['pageTrust']) ){$node['pageTrust'] = [];}
					if( isset($node['pageCurrent']) && !$this->_node_isResource($node) ){
						$hash  = md5($this->_url($node['pageCurrent']));
						if( isset($data['gazelleTrust'][$hash]) ){$node['pageTrust'] = $data['gazelleTrust'][$hash];}

						$parts = parse_url($node['pageCurrent']);
						if( isset($parts['scheme'],$parts['host']) && in_array($parts['scheme'],['http','https']) ){
							$domain = $parts['host'];
							$data['gazelleDomains'][$domain] = true;
						}

						/* Al menos para que entre el dominio */
						if( !empty($node['pageStageError']) || in_array($node['pageCode'],[999,408]) ){continue;}

						if( !empty($node['pageHeader']['content-transfer-encoding'])
						 && !empty($node['pageHeader']['content-disposition'])
						 && strpos($node['pageHeader']['content-disposition'],'attachment') !== false
						){
							//FIXME: esto se calcula en _node_isClean, recoger de allí
							$data['gazelleTags'][]  = 'attachment';
							$data['gazelleFlags'][] = 'attachment';
							if( strpos($node['pageHeader']['content-disposition'],'.exe') !== false ){
								/* Tiene pinta de virus */
								$data['gazelleTags'][]  = 'attachment-exe';
								$data['gazelleFlags'][] = 'attachment-exe';
							}
							if( strpos($node['pageHeader']['content-disposition'],'.apk') !== false ){
								/* Tiene pinta de app fraudulenta */
								$data['gazelleTags'][]  = 'attachment-apk';
								$data['gazelleFlags'][] = 'attachment-apk';
							}
						}

						if( !empty($node['pageHeader']['content-type'])
						 && $node['pageHeader']['content-type'] == 'application/octet-stream'
						 && strpos($node['pageCurrent'],'.apk') !== false ){
							//FIXME: esto se calcula en _node_isClean, recoger de allí
							$data['gazelleTags'][]  = 'attachment';
							$data['gazelleFlags'][] = 'attachment';

							/* Tiene pinta de app fraudulenta */
							$data['gazelleTags'][]  = 'attachment-apk';
							$data['gazelleFlags'][] = 'attachment-apk';
						}

						if( empty($parts['query']) ){
							//FIXME: sacar a utils
							$markAsBusted = true;
							/* Si hay una url sin parámetros, en principio no puede ser
							 * probablemente nos han pillado usando servidores de hosting
							 * y redireccionan fuera, marcamos para checkear más adelante */
							if( !empty($parts['path']) ){
								if( $markAsBusted && preg_match('!\/(?<name>[^\/]+(?<ext>\.js|\.png))$!',$parts['path'],$m)
								 && ($node['pageCode'] == 302 || $node['pageCode'] == 301)
								 && !empty($node['pageNext'])
								 && preg_match('!'.$m['ext'].'$!',$node['pageNext'])
								){
									/* Imaginemos que es una redirección de un recurso porque está
									 * corrigiendo simplemente la url
									 * Paso del <name>, voy por <ext> */
									$markAsBusted = false;
								}
								if( $markAsBusted && preg_match('!\/(?<name>[^\/]+(?<ext>\.js|\.png))$!',$parts['path'],$m)
								 && ($node['pageCode'] == 302 || $node['pageCode'] == 301)
								 && empty($node['pageHeader'])
								){
									/* Petición rota | basura */
									$markAsBusted = false;
								}

								/* Vamos a contar el número de elementos en path */
								$tmp = explode('/',$parts['path']);
								$tmp = array_filter($tmp);
								if( count($tmp) > 2 ){$markAsBusted = false;}
								if( $markAsBusted && preg_match('!(\/|\-|\.)([a-zA-Z]+[0-9]+[a-zA-Z0-9]*|[0-9]+[a-zA-Z]+[a-zA-Z0-9]*)(\/|\-|\.|$)!',$parts['path'],$m) ){
									//FIXME: entran cosas como html5
									/* Vamos a intentar detectar hashes */
									$markAsBusted = false;
								}
								if( $markAsBusted && preg_match('!(\&|;)[a-zA-Z0-9]+=[a-zA-Z0-9]+!',$parts['path'],$m) ){
									/* Parámetros encubiertos en la URL */
									$markAsBusted = false;
								}
								if( $markAsBusted && preg_match('!(^|\/|\-|\.)([a-zA-Z]+[0-9]+[a-zA-Z0-9]{5,}|[0-9]+[a-zA-Z]+[a-zA-Z0-9]{5,})(\/|\-|\.|$)!',$parts['host'],$m) ){
									/* Vamos a intentar detectar hashes en host */
									$markAsBusted = false;
								}
							}
							if( $markAsBusted ){
								$data['gazelleFlags'][] = 'check-busted';
							}
						}
					}

					/* Vamos a detectar recuadros de recaptcha */
					if( strpos($node['pageCurrent'],'https://www.google.com/recaptcha/api2') !== false ){
						$data['gazelleTags'][] = 'recaptcha';
						$data['gazelleFlags'][] = 'recaptcha';
					}

					/* Vamos a detectar blancazos del viejo mobusi */
					if( $node['pageCode'] == 200 && strpos($node['pageCurrent'],'m=1A3FTEST') !== false ){
						//$data['gazelleTags'][] = 'mobusi-blank';
						//$data['gazelleFlags'][] = 'mobusi-blank';
					}

					/* Detección de boxes por defecto */
					if( strpos($node['pageCurrent'],'market:') === 0 ){
						$data['gazelleTags'][] = 'market';
						if( preg_match('!id=(?<id>[^&]+)!',$node['pageCurrent'],$m) ){
							$data['gazelleTags'][] = 'market-'.$m['id'];
						}
					}
					if( strpos($node['pageCurrent'],'itms:') === 0
					 || strpos($node['pageCurrent'],'itmss:') === 0
					 || strpos($node['pageCurrent'],'itms-apps:') === 0
					 || strpos($node['pageCurrent'],'itms-appss:') === 0 ){
						$data['gazelleTags'][] = 'market';
						if( preg_match('!id(?<id>[0-9]+)!',$node['pageCurrent'],$m) ){
							$data['gazelleTags'][] = 'market-'.$m['id'];
						}
					}
					if( preg_match('!^https://itunes.apple.com/[^/]+/app/[^/]+/id(?<id>[0-9]+)!',$node['pageCurrent'],$m) ){
						$data['gazelleTags'][] = 'market';
						$data['gazelleTags'][] = 'market-'.$m['id'];
						/* Detectamos cuentas suspendidas */
						if( $node['pageCode'] == 400 ){
							$data['gazelleTags'][] = 'market-suspended';
						}
					}
					if( preg_match('!microsoft.com/[^/]+/store/apps/[^/]+/(?<id>[^/]+)$!',$node['pageCurrent'],$m) ){
						$data['gazelleTags'][] = 'market';
						$data['gazelleTags'][] = 'market-'.$m['id'];
					}

					if( isset($node['pageFrameBreak']) ){
						$data['gazelleTags'][] = 'page-break-frame';
					}
					if( isset($node['pageAlert']) ){
						$data['gazelleTags'][] = 'page-alert';
					}
					if( isset($node['pageMedia']) ){
						$data['gazelleTags'][] = 'page-media';
					}
				}
				unset($node);
				if( isset($node['pageCurl']) ){$data['gazelleFlags'][] = 'curl';}
			}
			/* END-Validamos los datos */

			/* INI-Resolver estado global de confianza de la traza */
			$this->resolveTrust($data);
			unset($data['tree'],$data['trust'],$data['final.node']);
			/* END-Resolver estado global de confianza de la traza */

			/* INI-Dominios en la traza */
			$data['gazelleDomainsTop'] = [];
			if( $data['gazelleDomains'] ){
				$data['gazelleDomains'] = array_keys($data['gazelleDomains']);
				$length = 0;
				foreach( $data['gazelleDomains'] as $k=>$domain ){
					$len = strlen($domain);
					if( ($length + $len) > 1000 ){unset($data['gazelleDomains'][$k]);continue;}
					$length += $len;
				}
				$data['gazelleDomains'] = array_values($data['gazelleDomains']);

				/* INI-Domains-Top */
				foreach( $data['gazelleDomains'] as $domain ){
					$data['gazelleDomainsTop'][] = $this->_domain($domain);
				}
				$data['gazelleDomainsTop'] = array_unique($data['gazelleDomainsTop']);
				$data['gazelleDomainsTop'] = array_values($data['gazelleDomainsTop']);
				/* END-Domains-Top */
			}
			/* END-Dominios en la traza */

			//FIXME: de gazelle trace domains a gazelleIPs

			$this->_validate_events($data);
			if( isset($data['gazelleData']) ){unset($data['gazelleData']);}
			if( isset($data['gazelleTrust']) ){unset($data['gazelleTrust']);}
			if( !isset($data['gazelleTrace']) || !$data['gazelleTrace'] || !is_array($data['gazelleTrace']) ){return ['errorDescription'=>'INVALID_TRACE','file'=>__FILE__,'line'=>__LINE__];}
			$data['gazelleTags']  = array_values(array_unique($data['gazelleTags']));
			$data['gazelleFlags'] = array_values(array_unique($data['gazelleFlags']));

			if( count($data['gazelleTrace']) > 400 ){
				/* Trazas demasiado largas, para poder almacenar bucles infinitos */
				$i = 0;
				foreach( $data['gazelleTrace'] as $k=>&$dummy ){
					if( $i++ > 400 ){unset($data['gazelleTrace'][$k]);}
				}
				unset($dummy);
				$data['gazelleTags'][]  = 'too-large';
				$data['gazelleFlags'][] = 'too-large';
			}
			return $data;
		}
		function log(&$data = [],&$oldData = []){
			if( empty($data['gazelleRequest']) ){return false;}
			if( $data !== $oldData ){
				if( !$this->_gazelle_trace_count_cache ){$this->_gazelle_trace_count_cache = new _gazelle_trace_count_cache();}
				$this->_gazelle_trace_count_cache->purgeCache($data['gazelleUser'],$data['gazelleRequestDate']);
			}
			if( !$this->_gazelle_request_TB ){$this->_gazelle_request_TB = new _gazelle_request_TB();}
			/* Actualizamos la request que equivale a esta traza */
			$this->_gazelle_request_TB->trace($data);
		}
		function _validate_events(&$data = [],$profileOB = false){
			/* INI-Profile Events */
			if( !$profileOB ){
				if( empty($this->profiles_TB) ){$this->profiles_TB = new profiles_TB();}
				if( !($profileOB = $this->profiles_TB->getByID($data['gazelleUser'])) ){return false;}
			}

			if( empty($profileOB['profileEvents']) ){return false;}
			$return = [];
			foreach( $profileOB['profileEvents'] as $eventOB ){
				if( empty($eventOB['trigger']) ){continue;}
				if( empty($eventOB['tags']) ){continue;}
				//if( array_search('any',$eventOB['trigger']) !== false && ($data['gazelleTraceTrust']['trace']['status'] != 'dirty') ){continue;}

				if( !empty($eventOB['trigger']['url']['domain']) ){
					$shouldMarkByURL = false;
					$checkCode  = !empty($eventOB['trigger']['url']['code']);
					$checkFinal = !empty($eventOB['trigger']['url']['final']);
					foreach( $data['gazelleTrace'] as &$node ){
						if( empty($node['pageCurrent']) ){continue;}
						if( empty($node['pageIsFinal']) && $checkFinal ){continue;}
						if( empty($node['pageCode']) && $checkCode ){continue;}
						$domain = $this->_domain($node['pageCurrent']);
						$host   = $this->_host($node['pageCurrent']);
						if( $domain != $eventOB['trigger']['url']['domain'] && $host != $eventOB['trigger']['url']['domain'] ){
							/* Si la url no coincide ni con dominio ni con host, continuamos */
							continue;
						}

						if( $checkCode && $node['pageCode'] != $eventOB['trigger']['url']['code'] ){continue;}
						$shouldMarkByURL = true;
					}
					unset($node);
				}

				if( empty($shouldMarkByURL) ){continue;}
				$return[] = $eventOB['_id'];

				if( !empty($eventOB['tags']) ){
					$data['gazelleTags'] = array_merge($data['gazelleTags'],$eventOB['tags']);
				}
				continue;
			}
			/* END-Acount Actions */

			return $return;
		}
		function _validate_trace( &$trace = [] ){
			/* INI-Por si no tiene id */
			foreach( $trace as $id=>&$node ){if( !isset($node['id']) ){$node['id'] = $id;}}
			unset($node);
			/* END-Por si no tiene id */

			$ids = array_map(function ($node) {return $node['id'];} ,$trace);
			$subnodes = $ids ? max($ids) : 0;

			foreach( $trace as &$node ){
				if (  isset($node['pageCode'],$node['pageMessage']) && $node['pageCode'] == 3 && preg_match('!Host [^ ]+ not found!i',$node['pageMessage']) ){
					/* PhantomJS no envia un mensaje HTTP estándar cuando el dominio no existe */
					$node = ['pageCode'=>404,'pageMessage'=>'Not Found']+$node;
				}
				if ( !isset($node['pageCode']) && isset($node['pageHeader']['status']) ) {
					/* Si no ha sido posible detectar en javascript el código de retorno de
					 * la página pero viene la cabecera, intentamos detectarla por PHP,
					 * intentaremos que no ocurra, pero por si acaso */
					$r = preg_match('!(?<code>[0-9]+)[ ]*(?<message>.+)!',$node['pageHeader']['status'],$m);
					if( $r ){$node = ['pageCode'=>$m['code'],'pageMessage'=>$m['message']]+$node;}
				}
				if( empty($node['pageNext']) && !empty($node['pageHeader']['location']) ){
					/* Hay un raro caso en phantom en el que esto ocurre y debuguear es un infierno */
					$node['pageNext'] = $node['pageHeader']['location'];
				}
				if( isset($node['pageNext']) && substr($node['pageNext'],0,4) !== 'http' && substr($node['pageNext'],0,1) == '/' ){
					/* La dirección del pageNext puede ser relativa, no tiene por qué ser
					 * una ruta absoluta, en caso de no serlo, la normalizamos */
					$parts = parse_url($node['pageCurrent']);
					$node['pageNext'] = $parts['scheme'].'://'.$parts['host'].$node['pageNext'];
				}


				/* INI-Creamos nodos para los media */
				if( isset($node['pageMedia']) ){foreach( $node['pageMedia'] as $med ){
					if( !isset($med['src']) ){continue;}
					$subnodes++;
					$parts = pathinfo($med['src']);
					$mime  = '';
					if( !isset($parts['extension']) ){$parts['extension'] = '';}
					if( $parts['extension'] == 'mp3' ){$mime = 'audio/mp3';}
					if( $parts['extension'] == 'ogg' ){$mime = 'audio/ogg';}

					$h = md5($this->_url($med['src']));
					$media = [
						 'id'=>$subnodes
						,'pageCurrent'=>$med['src']
						,'pageReferer'=>$node['pageCurrent']
						,'pageCode'=>'?'
						,'pageContentType'=>$mime
					];
					$trace[$media['id']] = $media;
				}}
				/* END-Creamos nodos para los media */

				if( isset($node['pageMessage']) ){$node['pageMessage'] = strtoupper($node['pageMessage']);}
			}
			unset($node);
		}
		function count($clause = [],$params = []){
			if ( !isset($params['no.cache']) && isset($clause['gazelleUser'], $clause['gazelleRequestDate']) ) {
				if ( !$this->_gazelle_trace_count_cache ) { $this->_gazelle_trace_count_cache = new _gazelle_trace_count_cache(); }
				if ( false === ($count = $this->_gazelle_trace_count_cache->getCache($clause)) ) {
					$count = $this->_count($clause, $params);
					$this->_gazelle_trace_count_cache->setCache($clause, $count);
				}
				return $count;
			}
			$count = $this->_count($clause, $params);
			return $count;
		}
		function getByURL($url = ''){
			$hash = md5($this->_url($url));
			return $this->getWhere(['gazelleHash'=>$hash]);
		}
		function resolveTrust(&$traceOB = [],$params = []){
			if( !$traceOB || !isset($traceOB['gazelleTrace']) ){return false;}
			if( !$this->_gazelle_trace_utils ){$this->_gazelle_trace_utils = new _gazelle_trace_utils();}

			$traceOB['gazelleTraceTrust'] = ['trace'=>array_fill_keys([
				 'pageIsClean'
				,'pageIsMalicious'
				,'pageIsMalware'
				,'pageIsPhishing'
				,'pageIsSuspicious'
				,'pageIsAttachment'
				,'pageIsAttachmentExe'
				,'pageIsAttachmentApk'
				,'pageIsCheckingChromeExtension'
			],0)];
			$traceOB['gazelleTraceTrust']['portals'] = [];

			foreach( $traceOB['gazelleTrace'] as &$node ){
				if( !isset($node['pageContentType']) && isset($node['pageHeader']['content-type']) ){
					$node['pageContentType'] = explode(';',$node['pageHeader']['content-type']);
					$node['pageContentType'] = $node['pageContentType'][0];
				}

				if( !empty($node['page-is']) ){unset($node['page-is']);}
				if( !empty($node['pageIsFinal']) ){unset($node['pageIsFinal']);}
				$trust = $this->_node_isClean($node);
				if( $trust['page.is.attachmentExe']
				 || $trust['page.is.attachmentApk']
				 || $trust['page.is.checkingChromeExtension'] ){
					$node['pageTrust']['_gazelle']['result'] = 'malware';
				}
				foreach( $trust as $status=>$value ){
					if( $status == 'portals' ){
						$traceOB['gazelleTraceTrust']['portals'] += $value;
						continue;
					}
					$key = 'pageIs'.ucfirst(str_replace('page.is.','',$status));
					$node[$key] = $value;
					$traceOB['gazelleTraceTrust']['trace'][$key] += intval($value);
				}
			}
			unset($node);

			if( !empty($traceOB['gazelleTraceTrust']['trace']['pageIsAttachmentExe'])
			 || !empty($traceOB['gazelleTraceTrust']['trace']['pageIsCheckingChromeExtension']) ){
				$traceOB['gazelleTraceTrust']['portals'][] = '_gazelle';
			}

			/* Calculamos status */
			$traceOB['gazelleTraceTrust']['traceStatus'] = 'clean';
			if( array_sum($traceOB['gazelleTraceTrust']['trace']) > $traceOB['gazelleTraceTrust']['trace']['pageIsClean'] ){$traceOB['gazelleTraceTrust']['traceStatus'] = 'dirty';}

			$tree  = $this->_gazelle_trace_utils->tree($traceOB);
			$walk_attach = function(&$n = []) use (&$walk_attach,&$traceOB){
				if( !isset($n['id']) ){
					foreach( $n as $k=>$rel ){
						$r = $walk_attach($n[$k]);
						if( $r ){return $r;}
					}
					return false;
				}

				if( isset($n['rels']) ){foreach( $n['rels'] as &$rel ){
					if( !empty($rel['pageIsAttachmentExe'])
					 || !empty($rel['pageIsAttachmentApk'])
					 || !empty($rel['pageIsCheckingChromeExtension']) ){
						/* Hay que subir también el pageTrust al referer porque si no el
						 * algoritmo lo marca en verde debido a portalsProfile */
						$n['pageIsMalware'] = intval($n['pageIsMalware']) + 1;
						//FIXME: pageIsClean debería ser entero?
						$n['pageIsClean']   = false;
						$n['pageTrust']['_gazelle']['result'] = 'malware';

						if( !empty($traceOB['gazelleTrace'][$n['id']]) ){
							$traceOB['gazelleTrace'][$n['id']]['pageIsMalware'] = $n['pageIsMalware'];
							$traceOB['gazelleTrace'][$n['id']]['pageIsClean']   = $n['pageIsClean'];
							$traceOB['gazelleTrace'][$n['id']]['pageTrust']['_gazelle']['result'] = $n['pageTrust']['_gazelle']['result'];
						}
					}

					$r = $walk_attach($rel);
					if( $r ){return $r;}
				}}
				return false;
			};
			$walk_attach($tree);

			/* INI-Final url */
			$final = $this->_gazelle_trace_utils->tree_getFinal($tree);
			if( !empty($final) ){
				if( !empty($traceOB['gazelleTrace'][$final['id']]) ){
					$traceOB['gazelleTrace'][$final['id']]['pageIsFinal'] = true;
				}
				$traceOB['gazelleTraceTrust']['final'] = [
					 'pageIsClean'      => $final['pageIsClean']
					,'pageIsMalicious'  => $final['pageIsMalicious']
					,'pageIsMalware'    => $final['pageIsMalware']
					,'pageIsPhishing'   => $final['pageIsPhishing']
					,'pageIsSuspicious' => $final['pageIsSuspicious']
					,'url'=>$final['pageCurrent']
					,'id'=>$final['id']
				];
			}
			/* END-Final url */

			/* INI-Creamos una jerarquía de nodos */
			$clean = function($array = []) use (&$clean,&$final){
				if( !is_array($array) ){return false;}
				if( !isset($array['id']) ){
					foreach( $array as $k=>$rel ){$array[$k] = $clean($array[$k]);}
					return $array;
				}

				foreach( $array as $k=>$v ){
					if( $k !== 'id' && $k !== 'rels' ){unset($array[$k]);}
				}

				if( isset($array['rels']) ){
					$array['childs'] = $clean($array['rels']);
					unset($array['rels']);
				}
				$array['final'] = $array['id'] == $final['id'] ? true : false;
				return $array;
			};
			$traceOB['tree'] = $clean($tree);
			/* END-Creamos una jerarquía de nodos */
			/* INI-Traza simple */
			$find_path = function($n = [],$path = []) use (&$find_path,&$final){
				if( !isset($n['id']) ){
					foreach( $n as $k=>$rel ){
						$r = $find_path($n[$k]);
						if( $r ){return $r;}
					}
					return false;
				}

				$path[] = $n['id'];
				if( $n['id'] == $final['id'] ){return $path;}
				if( isset($n['rels']) ){foreach( $n['rels'] as $rel ){
					$r = $find_path($rel,$path);
					if( $r ){return $r;}
				}}
				return false;
			};
			$route = $find_path($tree);
			$traceOB['final.node'] = [
				 'id'=>$final['id']
				,'path'=>$route
			];
			/* END-Traza simple */

			return true;
		}
		function trace_paint($traceOB = []){
//FIXME: esto no va aqui
			$_gazelle_trace_utils = new _gazelle_trace_utils();
			$tree = $_gazelle_trace_utils->tree($traceOB);
			//print_r($tree);exit;

			$_svg_uml = new _svg_uml($tree);
			return $_svg_uml->render();
		}
		function getWhere($clause = [],$params = []){
			if( isset($params['order']) && is_string($params['order']) ){
				$sort = [$params['order']=>1];
				if(($p = strpos($params['order'],' '))){
					/* Support for 'ORDER field (ASC|DESC)' */
					$field = substr($params['order'],0,$p);
					$o = substr($params['order'],$p+1);
					$sort = [$field=>($o == 'ASC') ? 1 : -1];
				}
				$params['sort'] = $sort;
				unset($params['order']);
			}
			$clause_count = count($clause);
			//FIXME: probablemente por aquí podría ir también si no hubiera sort
			//if( $clause_count == 1 && !empty($clause['gazelleUser']) && !empty($params['sort']['_id']) ){$params['hint'] = '_id_1_gazelleUser_1';}
			if( $clause_count == 2 && !empty($clause['gazelleUser']) && !empty($clause['gazelleTraceTrust.portals']) && !empty($params['sort']['_id']) ){$params['hint'] = 'gazelleUser_1_gazelleTraceTrust.portals_1';}

			if( !isset($params['hint']) && !empty($clause['gazelleUser']) && !empty($params['sort']['_id']) ){
				/* Si necesitamos ordenar por _id vamos a estar jodidos vayamos por donde vayamos, por lo
				 * que aunque perdamos algo de rendimiento en fetching, lo ganamos en ordering */
				//$params['hint'] = '_id_1_gazelleUser_1';
			}
//$clause['gazelleDomains'] = $clause['gazelleDomainsTop'];
//unset($clause['gazelleDomainsTop']);
//$params['hint'] = 'gazelleUser_1_gazelleDomains_1__id_-1';


			return $this->_getWhere($clause,$params);
		}
		function _q($q = '',$profileOB = []){
			/* Detectamos cuando sea una búsqueda directa de id */
			if( strlen($q) == 24 && preg_match('!^[0-9a-z]+$!',$q) ){$q = 'id:'.$q;}

			/* Convierte una queryString en clausula de búsqueda */
			$_params = new _params();
			$query  = $_params->query($q);
//print_r($query);exit;
			$clause = [];

			if( !empty($profileOB['_id']) ){$clause['gazelleUser'] = $profileOB['_id'];}
			if( isset($query['words']['tag']) ){$query['words']['label'] = $query['words']['tag'];}
			if( isset($query['words']['country']['$in']) ){
				if( count($query['words']['country']['$in']) == 1 && strpos($query['words']['country']['$in'][0],',') ){
					$query['words']['country']['$in'] = explode(',',$query['words']['country']['$in'][0]);
				}
				$clause['gazelleCountry'] = $query['words']['country'];
			}
			if( isset($query['words']['url']) ){
				foreach( $query['words']['url']['$in'] as $k=>$url ){
					if( strlen($url) == 32 && preg_match('!^[0-9a-z]+$!',$url) ){
						$clause['gazelleHash']['$in'][] = $url;
					}else{
						$hash = md5($this->_url($url));
						$clause['gazelleHash']['$in'][] = $hash;
					}
				}
			}
			if( isset($query['words']['domain']) ){
				foreach( $query['words']['domain']['$in'] as $domain ){
					if( $this->_domain($domain) == $domain ){
						$clause['gazelleDomainsTop']['$in'][] = $domain;
					}else{
						$clause['gazelleDomains']['$in'][] = $domain;
					}
				}
			}
			if( isset($query['words']['!domain']) ){
				foreach( $query['words']['!domain']['$in'] as $domain ){
					if( $this->_domain($domain) == $domain ){
						$clause['gazelleDomainsTop']['$nin'][] = $domain;
					}else{
						$clause['gazelleDomains']['$nin'][] = $domain;
					}
				}
			}
			if( isset($query['words']['domaint']) ){$clause['gazelleDomainsTop'] = $query['words']['domaint'];}
			if( isset($query['words']['date']) ){
				if( count($query['words']['date']['$in']) == 1 && strpos($query['words']['date']['$in'][0],',') ){
					$query['words']['date']['$in'] = explode(',',$query['words']['date']['$in'][0]);
				}
				$clause['gazelleRequestDate'] = $query['words']['date'];
			}
			if( isset($query['words']['id']['$in']) ){$clause['_id'] = new MongoId(reset($query['words']['id']['$in']));}
			if( isset($query['words']['ids']['$in']) ){
				$ids = array_map(function($id){return new MongoId($id);},$query['words']['ids']['$in']);
				$clause['_id'] = ['$in'=>$ids];
			}
			if( isset($query['words']['label']) ){
				$clause['gazelleTags'] = $query['words']['label'];
				/* Necesitamos convertir las labels de perfil de su formato texto a su id */
				if( !empty($clause['gazelleTags']) && !empty($profileOB['profileTags']) ){
					foreach( $clause['gazelleTags']['$in'] as &$label ){
						foreach( $profileOB['profileTags'] as $tag ){
							if( $label == $tag['name'] ){$label = $tag['id'];}
						}
					}
					unset($label);
				}
			}

			/* INI-Optimización */
			if( !empty($clause['gazelleDomains']['$in'])
			 && count($clause['gazelleDomains']['$in']) == 1
			 && empty($clause['gazelleDomains']['$nin']) ){$clause['gazelleDomains'] = reset($clause['gazelleDomains']['$in']);}
			/* END-Optimización */
			//if( !empty($query['query']) ){ $clause['$text'] = ['$search'=>$query['query']];	}

			return $clause;
		}
	}
	/* END-trace */

	class _gazelle_trace_utils{
		use _url;
		use _gazelle_trace_nodes;
		function tree($traceOB = []){
			if( !$traceOB ){return false;}
			if( isset($traceOB['gazelleTrace']) ){
				if( empty($traceOB['_id']) ){$traceOB['_id'] = uniqid();}
				$__id = $traceOB['_id'];
				$traceOB = $traceOB['gazelleTrace'];
			}
			if( isset($traceOB['count']) ){unset($traceOB['count']);}
			$cleanPageTrust = false;

//print_r($traceOB);exit;
			$nodes = [];
			$tree  = [];

			/* La primera vuelta hace un poco de cleanup y establece los iconos
			 * para un posible pintado en svg. */
			foreach( $traceOB as $n ){
				if( !isset($n['id']) ){$n['id'] = uniqid();}
				if( empty($n['pageNext']) && !empty($n['pageHeader']['location']) ){
					/* Hay un raro caso en phantom en el que esto ocurre y debuguear es un infierno */
					$n['pageNext'] = $n['pageHeader']['location'];
				}

				$h = md5($this->_url($n['pageCurrent']));
				if( !isset($n['rels']) ){$n['rels'] = [];}
				$n['hash'] = $h;
				$n['name'] = $n['pageCurrent'];
				if( isset($n['pageContentType']) && $n['pageContentType'] ){
					$n['type'] = explode(';',$n['pageContentType']);
					$n['type'] = $n['type'][0];
					$n['name'] = $n['type'];
					$n['background'] = str_replace(['text/html','text/javascript','binary/octet-stream','image/gif','image/png','image/jpeg'],['#f0e7d4','#40bfa6','#40bfa6','#f98d0b','#f98d0b','#f98d0b'],$n['type']);
/* NO MOSTRAR print_r cuando se ejecute desde CLI (para evitar romper la ejecución de workers) */
if( !isset($n['background'][0]) && !isset($GLOBALS['w.cli']) ){
print_r($n);
exit;
}
					if( isset($n['background'][0]) && $n['background'][0] != '#' ){unset($n['background']);}
				}
				if( strpos($n['pageCurrent'],'https://www.google.com') === 0 ){$n['icon'] = '../images/logos.svg/google.svg';}
				if( strpos($n['pageCurrent'],'http://www.googletagmanager.com') === 0 ){$n['icon'] = '../images/logos.svg/google.svg';}
				if( strpos($n['pageCurrent'],'http://www.google-analytics.com') === 0 ){$n['icon'] = '../images/logos.svg/google.svg';}
				if( strpos($n['pageCurrent'],'http://www.googleadservices.com') === 0 ){$n['icon'] = '../images/logos.svg/google.svg';}
				if( strpos($n['pageCurrent'],'https://googleads.g.doubleclick.net') === 0 ){$n['icon'] = '../images/logos.svg/google.svg';}
				$n['extra'] = ' data-type="link" data-trace="'.base64_encode(json_encode($n)).'" ';
				//FIXME: posiblemente user pageStart,pageEnd si fueran microtime(1)
				$t = $n['id'];
				$nodes[$h][$t] = $n;

				$subnodes = 0;
				/* INI-Creamos nodos para los media */
				if( isset($n['pageMedia']) ){foreach( $n['pageMedia'] as $med ){
					if( !isset($med['src']) ){continue;}
					$h = md5($this->_url($med['src']));
					/* Esto ya debería estar en la traza, si no lo estuviera lo añadimos.
					 * En caso de estar previamente, se evitarán duplicados en base al hash
					 * (porque esa posición ya existirá previamente)
					 * EN EL FUTURO: debería desaparecer porque hay soporte en el "save" */
					if( isset($nodes[$h]) ){continue;}
					$subnodes++;
					$parts = pathinfo($med['src']);
					$mime  = '';
					if( !isset($parts['extension']) ){$parts['extension'] = '';}
					if( $parts['extension'] == 'mp3' ){$mime = 'audio/mp3';}
					if( $parts['extension'] == 'ogg' ){$mime = 'audio/ogg';}

					$media = [
						 'id'=>$n['id'].'.'.$subnodes
						,'pageCurrent'=>$med['src']
						,'pageReferer'=>$n['pageCurrent']
						,'pageCode'=>'?'
						,'pageContentType'=>$mime
						,'hash'=>$h
						,'name'=>$med['src']
						,'type'=>$mime
					];
					$media['extra'] = ' data-type="link" data-trace="'.base64_encode(json_encode($media)).'" ';
					$nodes[$h][$media['id']] = $media;
				}}
				/* END-Creamos nodos para los media */

				unset($n);
			}

			if( $cleanPageTrust ){
				/* Esto normalmente se activa para <debug> , para poder visualizar
				 * con mayor facilidad los nodos. */
				foreach( $nodes as &$subnodes ){
					foreach( $subnodes as &$node ){
						unset($node['pageTrust']);
					}
					unset($node);
				}
				unset($subnodes);
			}

			foreach( $nodes as $subnodes ){
				/* Se supone que los nodos han sido agrupados por el hash de su url, por si la traza
				 * para un par de veces por la misma url para confundir, el objetivo es decidir el
				 * referer de cada nodo */
				foreach( $subnodes as $n ){
					if( !isset($n['pageNext']) ){continue;}
					if(  isset($n['gazelle-referer']) ){continue;} /* Puede venir cuando la traza sea de chrome */
					if(  isset($n['parentFrameId']) && $n['parentFrameId'] < 0 ){continue;} /* El nodo 0 de las trazas de chrome no tiene gazelle-referer */

					$nextHasDomain = substr($n['pageNext'],0,4) === 'http'
						|| substr($n['pageNext'],0,6) === 'market'
						|| substr($n['pageNext'],0,6) === 'itms-a'
						|| substr($n['pageNext'],0,6) === 'itmss:';
					/* En ocasiones el location no tiene por qué empezar por http:// en caso de no
					 * hacerlo lo añadimos nosotros, no debería ocurrir de todas maneras */
					if( !$nextHasDomain && substr($n['pageNext'],0,1) === '/' ){
						$parts = parse_url($n['pageCurrent']);
						$n['pageNext'] = $parts['scheme'].'://'.$parts['host'].$n['pageNext'];
						$nextHasDomain = true;
					}
					if( !$nextHasDomain && substr($n['pageNext'],0,1) !== '/' ){
						$parts = parse_url($n['pageCurrent']);
						if( !empty($parts['path']) ){
							$path  = explode('/',$parts['path']);
							array_pop($path);
							$path  = implode('/',$path);
							if( substr($path,-1) != '/' ){$path .= '/';}
							$n['pageNext'] = $parts['scheme'].'://'.$parts['host'].$path.$n['pageNext'];
							$nextHasDomain = true;
						}
					}

					$n['pageNextPosibilities'][] = $n['pageNext'];

					/* INI-Necesitamos quitar el hash en algunas urls */
					$parts = parse_url($n['pageNext']);
					if( !empty($parts['host']) ){
						$pageNext = $parts['scheme'].'://'.$parts['host']
							.( isset($parts['port']) && $parts['port'] ? ':'.$parts['port'] : '')
							.( isset($parts['path']) && $parts['path'] ? $parts['path'] : '')
							.( isset($parts['query']) && $parts['query'] ? '?'.$parts['query'] : '' );
						$n['pageNextPosibilities'][] = $pageNext;

						if( empty($parts['path']) && !empty($parts['query']) ){
							/* Otra posibilidad de matching, que en el next vaya el dominio sin '/'
							 * y en el pageCurrent vaya con '/', ej:
							 * http://passinst.com?h=39D -> http://passinst.com/?h=39D
							 */
							$parts['path'] = '/';
							$pageNext = $parts['scheme'].'://'.$parts['host']
								.( isset($parts['port']) && $parts['port'] ? ':'.$parts['port'] : '')
								.( isset($parts['path']) && $parts['path'] ? $parts['path'] : '')
								.( isset($parts['query']) && $parts['query'] ? '?'.$parts['query'] : '' );
							$n['pageNextPosibilities'][] = $pageNext;
						}
					}
					/* END-Necesitamos quitar el hash en algunas urls */
					$lastChar = substr($n['pageNext'],-1);
					if( $lastChar != '/' ){$n['pageNextPosibilities'][] = $n['pageNext'].'/';}
					if( $lastChar == '/' ){$n['pageNextPosibilities'][] = substr($n['pageNext'],0,-1);}

					/* Vamos a intentar machear con alguno de los nodos */
					$found = false;
					foreach( $n['pageNextPosibilities'] as $try ){
						$h = md5($this->_url($try));
						if( isset($nodes[$h]) ){$found = true;break;}
					}
					if( !$found ){continue;}

					//if(  isset($nodes[$h]['pageReferer']) ){continue;}
					if( in_array($n['pageCode'],[301,302]) && isset($n['pageStageError']) && $n['pageStageError'] ){
//FIXME: aquí quizá hay que meter soporte para los errores de chrome?
						/* No intentamos asignar nodos extraños, si es un error de phantom (pageStageError)
						 * y tiene una redirección posiblemente es un retry */
						continue;
					}


					/* Hacemos una limpia de los nodos que ya han sido asignados, si no quedan nodos
					 * pendientes de asignar salimos, esto provoca nodos huerfanos, pero no podemos hacer
					 * más */
					$tmp = $nodes[$h];
					$tmp = array_map(function($s) use ($n){
						$s['diff'] = abs($s['id']-$n['id']);
						return isset($s['gazelle-referer']) ? false : $s;
					},$tmp);
					$tmp = array_filter($tmp);
					if( !$tmp ){continue;}

					reset($tmp);
					uasort($tmp,function($a,$b){
						if( $a['diff'] == $b['diff'] ){return 0;}
						return ($a['diff'] < $b['diff']) ? -1 : 1;
					});
					do{
						if( count($tmp == 1) ){$id = key($tmp);break;}

						/* Si hay más de 1 nodo con esta url encajamos la url con respecto al id */
						foreach( $tmp as $tm ){
							if( ($id = $tm['id'])
							// && $id > $n['id']
							 && isset($nodes[$h][$id]['pageReferer'],$n['pageReferer'])
							 && $nodes[$h][$id]['pageReferer'] == $n['pageReferer'] ){
								/* Asignación directa, si se cumplen todas estas cosas
								 * asignamos directamente porque este es el nodo que buscamos */
								break 2;
							}
						}

						reset($tmp);
						uasort($tmp,function($a,$b){
							if( $a['diff'] == $b['diff'] ){return 0;}
							return ($a['diff'] < $b['diff']) ? -1 : 1;
						});
						while( ($id = key($tmp)) && $id < $n['id'] ){next($tmp);}
						if( !$id || $id < $n['id'] ){
							if( isset($__id) ){echo PHP_EOL.$__id.PHP_EOL;exit;}
							echo $id.PHP_EOL;
							print_r($n);
							print_r($tmp);
							print_r($nodes[$h]);
							//*/
							//echo PHP_EOL.$__id.PHP_EOL;
							echo 'aerror 5645';exit;
						}
					}while(false);

					$nodes[$h][$id]['pageReferer'] = $n['pageCurrent'];
					$nodes[$h][$id]['hash'] = $h;
					$nodes[$h][$id]['gazelle-referer'] = $n['id'];
				}
			}

			/* [pageCurrent] => http://xxxx
			 * [pageHistory] => Array( [0] => http://xxxx?y=z )
			 * --------------------------------------------------------------------------------------------
			 * Hay páginas que manipulan el historial, si exite una manipulación del historial quiere decir
			 * que en todas las páginas cuyo padre es http://xxxx?y=z realmente el padre es http://xxxx y
			 * necesitamos tener una referencia para hacer la conversión
			 */
			$historyHacks = [];
			foreach( $nodes as $subnodes ){
				foreach( $subnodes as $t=>$n ){
					if( !isset($n['pageHistory']) ){continue;}
					foreach( $n['pageHistory'] as $u ){
						$h = md5($this->_url($u));
						$historyHacks[$h][$n['id']] = $n['hash'];

						/* INI-Eliminamos el hash de la url */
						$parts = parse_url($u);
						$test = $parts['scheme'].'://'.$parts['host']
						.( isset($parts['path']) && $parts['path'] ? $parts['path'] : '')
						.( isset($parts['query']) && $parts['query'] ? '?'.$parts['query'] : '' );
						if( $test != $u ){
							/* Si la url de hack de history tiene algún tipo hash es posible
							 * que no coincida el md5 a la hora de establecer el match, por ello
							 * añadimos una nueva referencia sin hash para permitir establecer
							 * la conexión */
							$h = md5($this->_url($test));
							$historyHacks[$h][$n['id']] = $n['hash'];
						}
						/* END-Eliminamos el hash de la url */
					}
				}
			}

			/* INI-Relación por referer */
			foreach( $nodes as $k=>$subnodes ){
				foreach( $subnodes as $t=>$n ){
					if( !isset($n['pageReferer']) || isset($n['gazelle-referer']) ){continue;}

					$h = md5($this->_url($n['pageReferer']));
					$lastChar = substr($n['pageReferer'],-1);
					/* Si se ha modificado el historial (hack de historial) usamos el fast-translate de
					 * $historyHacks para saber el referer canonical que corresponde a dicho recurso */
					if( !isset($nodes[$h]) && isset($historyHacks[$h]) ){$h = end($historyHacks[$h]);}
					if( !isset($nodes[$h]) ){$h = md5($n['pageReferer']);}
					if( !isset($nodes[$h]) && $lastChar != '/' ){$h = md5($this->_url($n['pageReferer'].'/'));}
					if( !isset($nodes[$h]) && $lastChar == '/' ){$h = md5($this->_url(substr($n['pageReferer'],0,-1)));}
					if( !isset($nodes[$h]) ){continue;}

					reset($nodes[$h]);
					$id = count($nodes[$h]) == 1 ? key($nodes[$h]) : false;
					if( $id === false ){
						/* Si hay más de 1 nodo con esta url encajamos la url con respecto al id */
						while( ($tmp = key($nodes[$h])) && $tmp < $n['id'] ){$id = $tmp;next($nodes[$h]);}
						// FIXME:
						// if( !$id || $id > $n['id'] ){echo 'berror 5645';exit;}
						if( !$id || $id > $n['id'] ){continue;}
					}

					$nodes[$k][$t]['gazelle-referer'] = $id;
				}
			}
			/* END-Relación por referer */

			/* INI-Relación por pageRedirect */
			foreach( $nodes as $k=>$subnodes ){
				foreach( $subnodes as $t=>$n ){
					if( !isset($n['pageRedirect']) ){continue;}
					foreach( $n['pageRedirect'] as $redirect ){
						$h = md5($this->_url($redirect));
						$lastChar = substr($redirect,-1);
						if( !isset($nodes[$h]) && isset($historyHacks[$h]) ){$h = end($historyHacks[$h]);}
						if( !isset($nodes[$h]) ){$h = md5($redirect);}
						if( !isset($nodes[$h]) && $lastChar != '/' ){$h = md5($this->_url($redirect.'/'));}
						if( !isset($nodes[$h]) && $lastChar == '/' ){$h = md5($this->_url(substr($redirect,0,-1)));}
						if( !isset($nodes[$h]) ){continue;}

						reset($nodes[$h]);
						$id = count($nodes[$h]) == 1 ? key($nodes[$h]) : false;
						if( $id === false ){
							$min = $n['id'];
							$ids = array_keys($nodes[$h]);
							$ids = array_filter($ids,function($value) use ($min){return ($value >= $min);});
							if( !$ids ){continue;}
							$id  = array_shift($ids);
						}

						if( isset($nodes[$h][$id]['gazelle-referer']) ){
							/* Solo enlazamos aquellos que no hayas sido asignados por
							 * otros medios más fiables */
							continue;
						}
						$nodes[$h][$id]['gazelle-referer'] = $n['id'];
					}
				}
			}
			/* END-Relación por pageRedirect */

			$tmp = [];
			foreach( $nodes as $k=>$subnodes ){foreach( $subnodes as $t=>$n ){
				$tmp[$t] = $n;
			}}
			$nodes = $tmp;

			foreach( $nodes as $k=>$n ){
				if( !isset($n['gazelle-referer']) ){$tree[] = &$nodes[$k];continue;}
				$h = $n['gazelle-referer'];
				$nodes[$h]['rels'][] = &$nodes[$k];
				unset($n);
			}
			return $tree;
		}
		function tree_calculateWeight(&$node = [],$l = 0){
			if( !is_array($node) ){return false;}
			if( !isset($node['id']) ){
				foreach( $node as &$rel ){
					$this->tree_calculateWeight($rel);
				}
				unset($rel);
				return true;
			}

			$node['weight'] = 0;
			if( isset($node['pageCode']) && $node['pageCode'] == 200 ){$node['weight'] += 10;}
			if( isset($node['type']) && $node['type'] == 'text/html' ){$node['weight'] += 10;}
			if( isset($node['pageCode'],$node['type']) && in_array($node['pageCode'],[200,404,403]) && $node['type'] == 'text/html' ){
				$node['weight'] += $l/10;
			}
			if( !empty($node['pageCurrent']) ){
				if( strpos($node['pageCurrent'],'itms-appss:') === 0
				 || strpos($node['pageCurrent'],'itms-apps:') === 0
				 || strpos($node['pageCurrent'],'itmss:') === 0
				 || strpos($node['pageCurrent'],'market:') === 0 ){
					/* Detección de appstore */
					$node['weight'] += 1000;
				}
				if( strpos($node['pageCurrent'],'https://www.google.com/recaptcha/api2/') === 0 ){
					/* Si es la api de recaptcha, es un iframe misdetection */
					$node['weight'] = 0;
				}
			}
			if( isset($node['pageCurrent']) && substr($node['pageCurrent'],-4) == '.apk' ){
				/* Detección de appstore */
				$node['weight'] += 1000;
			}

			if( isset($node['rels']) ){
				if( count($node['rels']) > 1 ){$node['weight'] += 10;}
				$l++;
				foreach( $node['rels'] as &$rel ){
					if( isset($rel['type']) && in_array($rel['type'],['text/javascript','application/javascript','application/x-javascript']) ){$node['weight'] += 2;}
					$this->tree_calculateWeight($rel,$l);
				}
				unset($rel);
			}

			/*$filtered = array_intersect_key( $node, array_flip( ['pageCurrent','pageCode','type','weight'] ) );
			echo 'level: '.$l.PHP_EOL;
			print_r($filtered).PHP_EOL;//*/
			return true;
		}
		function tree_getFinal(&$node = []){
//FIXME: necesitamos truqui de las apps
			if( !is_array($node) ){return false;}
			if( !isset($node['id']) ){
				$this->tmpnode = false;
				$this->tree_calculateWeight($node);
				foreach( $node as $rel ){$this->tree_getFinal($rel);}
				$return = $this->tmpnode;
				$this->tmpnode = false;
				return $return;
			}

			if( !$this->tmpnode ){$this->tmpnode = $node;}
			if( $this->tmpnode['weight'] < $node['weight'] ){$this->tmpnode = $node;}

			if( isset($node['rels']) ){foreach( $node['rels'] as $rel ){
				$testWeight = $this->tree_getFinal($rel);
			}}
		}
		function paint_table_ai($gtraceOB = []){
			if( !$gtraceOB ){return false;}
			//FIXME: el metodo del tree debería estar aqui
			$tree = $this->tree($gtraceOB);

			$_utils = new _utils();
			/* INI-Traza completa */
			$html = '';
			$width = 0;
			$process_node = function($n = [],$level = 1) use (&$html,&$process_node,&$width,&$_utils){
				if( !isset($n['pageReferer']) ){$n['pageReferer'] = '';}
				if( !isset($n['pageNext']) ){$n['pageNext'] = '';}
				if( !isset($n['pageCode']) ){$n['pageCode'] = '';}
				if( !isset($n['type']) ){$n['type'] = '';}
				if( !isset($n['pageIsClean']) ){$n['pageIsClean'] = true;}
				$hash = uniqid();

				$parts = parse_url($n['pageCurrent']);
				if ( !isset($parts['host']) ) { $parts['host'] = ''; }
				$trust = $n['pageIsClean'] ? 'green' : 'red';
				$n['html.icons'] = '';
				$n['html.pageCurrent'] = '<span class="'.( $n['pageIsClean'] ? 'green' : 'red' ).'">'.$parts['scheme'].'://'.$parts['host'].'</span><span class="grey-light">'.( isset($parts['path']) ? $parts['path'] : '' ).( isset($parts['query']) ? '?'.$parts['query'] : '' ).'</span>';
				$n['html.trustIcon'] = $n['pageIsClean'] ? '<i class="fa fa-check green"></i>' : '<i class="fa fa-warning red"></i>';
				$n['html.breakIcon'] = isset($n['pageFrameBreak']) && $n['pageFrameBreak'] ? '<i class="fa fa-chain-broken red" aria-hidden="true"></i>' : '';
				$n['html.soundIcon'] = isset($n['pageMedia']) && $n['pageMedia'] ? '<i class="fa fa-volume-up blue-electric" aria-hidden="true" title="sound"></i>' : '';
				$n['html.alertIcon'] = isset($n['pageAlert']) && $n['pageAlert'] ? '<i class="fa fa-bullhorn blue-electric" aria-hidden="true" title="alert"></i>' : '';
				if( substr($n['pageCurrent'],0,7) == 'market:'
				 || substr($n['pageCurrent'],0,7) == 'itmss:/' ){
					$n['html.icons'] .= ' <i class="fa fa-dropbox green"></i> ';
				}

				$left  = (($level*10)-10);
				$html .= '<li class="row" data-level="'.$level.'">'
					.'<div class="level-indicator-holder" style="width:{%trace.sequence.width%}px;"><div class="level-indicator bg-'.$trust.'" style="margin-left:'.$left.'px;">'.base_convert($level,10,36).'</div></div>'.PHP_EOL
					.'<div>'
					.'	<p class="breakword">'.$n['html.trustIcon'].' '.$n['html.icons'].' '.$n['html.breakIcon'].' '.$n['html.soundIcon'].' '.$n['html.alertIcon'].' '.$n['pageCurrent'].'</p>'
					.'	'.( !empty($n['pageAlert']) ? '<div class="block-warning"><h3><i class="fa fa-bullhorn" aria-hidden="true"></i> Page Alert</h3><p>'.$n['pageAlert'].'</p></div>' : '' )
					.'	'.( !empty($n['pageIsAttachmentExe']) ? '<div class="block-warning red"><h3><i class="fa fa-cloud-download" aria-hidden="true"></i> Dangerous Download</h3><p>This page is downloading a .exe file.</p></div>' : '' )
					.'	'.( !empty($n['pageIsAttachmentApk']) ? '<div class="block-warning red"><h3><i class="fa fa-cloud-download" aria-hidden="true"></i> Dangerous Download</h3><p>This page is downloading a .apk file.</p></div>' : '' )
					.'	'.( !empty($n['pageIsCheckingChromeExtension']) ? '<div class="block-warning red"><h3><i class="fa fa-chrome" aria-hidden="true"></i> Extension Check</h3><p>This call is probably checking the existence of a Chrome Extension installed in order to comunicate with it.</p></div>' : '' )
					.'	'.( !empty($n['is.reference']) ? '<div class="block-warning"><h3><img src="'.$n['referenceOB']['src.reference.16'].'" title="'.$n['referenceOB']['referenceName'].'"/> '.$n['referenceOB']['referenceName'].'</h3></div>' : '' )
					.'	{%'.$hash.'%}'
					.'</div>'.PHP_EOL
					.'<div>'.$n['type'].'</div>'.PHP_EOL
					.'<div><a target="_blank" href="'.presentation_trace_http_status($n['pageCode']).'">'.$n['pageCode'].' '.$_utils->get_http_code_description($n['pageCode']).' ('.$_utils->get_http_group_description($n['pageCode']).')</a></div></li>'.PHP_EOL;

				$w = $left + 10;/* 10 es el ancho del indicador */
				if( $w > $width ){$width = $w;}

				$resources = '';
				if( isset($n['rels']) && $n['rels'] ){
					$resources = '<ul class="grey-light breakword" style="margin-left:10px;">'.PHP_EOL;
					$l = $level+1;
					foreach( $n['rels'] as $rel ){
						if( isset($n['pageCode']) && $n['pageCode'] == 200 && $this->_node_isResource($rel) ){
							$icon  = 'fa-file-code-o';
							$color = '';
							if( isset($rel['pageContentType']) && (strpos($rel['pageContentType'],'audio/mp3') !== false || strpos($rel['pageContentType'],'audio/ogg') !== false) ){$icon = 'fa-file-audio-o';$color = 'blue';}
							if( substr($rel['pageCurrent'],0,5) == 'data:' ){$rel['pageCurrent'] = substr($rel['pageCurrent'],0,100).'[...]';}

							$resources .= '<li class="'.$color.'"><i class="fa '.$icon.'"></i> '.$rel['pageCurrent'].'</li>'.PHP_EOL;
							continue;
						}
						$process_node($rel,$l);
					}
					$resources .= '</ul>'.PHP_EOL;
				}
				$html = str_replace('{%'.$hash.'%}',$resources,$html);
			};
			foreach( $tree as $start ){$process_node($start);}
			$width += 4 + 4;/* El padding de la tabla */
			/* END-Traza completa */
			return [
				 'html'=>$html
				,'width'=>$width
			];
		}

		function array_table_ai($gtraceOB = []){
			if ( !$gtraceOB ) { return []; }
			//FIXME: el metodo del tree debería estar aqui
			$tree = $this->tree($gtraceOB);
			$_utils = new _utils();
			/* INI-Traza completa */
			$result = [];
			$process_node = function(&$n = [],$level = 1) use (&$result,&$process_node,&$_utils) {
				$n['nodeDepth'] = $level;
				if( isset($n['rels']) && $n['rels'] ){
					$l = $level+1;
					foreach( $n['rels'] as &$rel ){
						$result[$rel['id']] = $rel;
						$process_node($rel, $l);
					}
				}
				unset($n['pageHeader'], $n['pageHistory'], $n['pageAgent'], $n['extra'], $n['pageReferer'], $n['pageNext'], $n['pageStageStart'], $n['pageStart'], $n['pageStageEnd'], $n['pageEnd'], $n['pageRedirect'], $n['hash'], $n['background']);
				if( !isset($n['pageCode']) ){$n['pageCode'] = '';}
				if( !isset($n['type']) ){$n['type'] = '';}
				if( !isset($n['pageIsClean']) ){$n['pageIsClean'] = true;}

				$parts = parse_url($n['pageCurrent']);
				if ( !isset($parts['host']) )  { $parts['host'] = ''; }
				if ( !isset($parts['path']) )  { $parts['path'] = ''; }
				if ( !isset($parts['query']) ) { $parts['query'] = ''; }
				$n['pageCurrent.parsed'] = $parts;

				$n['isStore'] = ( substr($n['pageCurrent'],0,7) == 'market:' || substr($n['pageCurrent'],0,7) == 'itmss:/' );
				$n['nodeDepth'] = $level;
				$n['pageAlert'] = isset($n['pageAlert']) ? (bool)$n['pageAlert'] : false;
				$n['pageIsAttachmentExe'] = isset($n['pageIsAttachmentExe']) ? (bool)$n['pageIsAttachmentExe'] : false;
				$n['pageIsAttachmentApk'] = isset($n['pageIsAttachmentApk']) ? (bool)$n['pageIsAttachmentApk'] : false;
				$n['pageIsCheckingChromeExtension'] = isset($n['pageIsCheckingChromeExtension']) ? (bool)$n['pageIsCheckingChromeExtension'] : false;
				$n['isReference'] = !empty($n['is.reference']);
				$n['reference'] = $n['isReference'] ? [ 'img' => str_replace('?s=16', '', $n['referenceOB']['src.reference.16']), 'name' => $n['referenceOB']['referenceName'] ] : [];
				$n['httpStatusUrl'] = presentation_trace_http_status($n['pageCode']);
				$n['httpStatusDesc'] = $_utils->get_http_code_description($n['pageCode']);
				$n['httpStatusGroupDesc'] = $_utils->get_http_group_description($n['pageCode']);

				if( $n['pageCode'] == 200 && $this->_node_isResource($n) ){
					$n['is.resource'] = true;
					$n['is.audio'] = ( isset($n['pageContentType']) && (strpos($n['pageContentType'],'audio/mp3') !== false || strpos($n['pageContentType'],'audio/ogg') !== false) );
					if ( substr($n['pageCurrent'],0,5) == 'data:' ) { $n['pageCurrent.show'] = substr($n['pageCurrent'],0,100).'[...]'; }
				}
				$result[$n['id']] = $n;
			};
			foreach( $tree as &$start ) { $process_node($start); }
			/* END-Traza completa */
			ksort($result);
			return $result;
		}

		function trace_calculateProfile(&$traceOB = [],&$profileOB = []){
			/* INI-Preferencias de perfil
			 * si el usuario tiene preferencias de perfil, las aplicamos */
			if( !empty($profileOB['profileConfig']['excluded-portals']) ){
				$excluded = $profileOB['profileConfig']['excluded-portals'];
				foreach( $excluded as &$portal ){
					$portal = str_replace('_virustotal.','v.',$portal);
					if( !strpos($portal,'.') ){$portal = 'i.'.$portal;}
				}
				unset($portal);

				/* INI-Calculamos los portales globales */
				$traceOB['gazelleTraceTrust']['portalsProfile'] = [];
				$traceOB['gazelleTraceTrust']['traceStatusProfile'] = 'clean';
				if( !empty($traceOB['gazelleTraceTrust']['portals']) ){
					$traceOB['gazelleTraceTrust']['portalsProfile'] = array_diff($traceOB['gazelleTraceTrust']['portals'],$excluded);
					if( !empty($traceOB['gazelleTraceTrust']['portalsProfile']) ){
						$traceOB['gazelleTraceTrust']['traceStatusProfile'] = 'dirty';
					}
				}
				/* END-Calculamos los portales globales */
			}

			if( !empty($traceOB['gazelleTrace']) ){
				foreach( $traceOB['gazelleTrace'] as &$node ){
					if( !empty($node['pageTrust']) ){
						$node['trust']['portals'] = [];
						$portals = [];
						foreach( $node['pageTrust'] as $portal=>$trust ){
							if( isset($trust['errorDescription']) ){continue;}
							//if( $portal != '_virustotal' ){continue;}
							if( !empty($trust['results']) ){foreach( $trust['results'] as $subportal=>$subtrust ){
								$id = $portal.'.'.$subportal;
								if( isset($this->banned_portals[$id]) ){continue;}
								$result = strtolower($subtrust['result']);
								if( in_array($result,['','clean site','unrated site']) ){continue;}
								$portals[$id] = $result;
							}}
							if( !empty($trust['result']) ){
								$result = strtolower($trust['result']);
								if( in_array($result,['','clean site','unrated site']) ){continue;}
								$portals[$portal] = $result;
							}
						}

						/* INI-Cantamos los portales */
						$node['trust']['portals'] = array_keys($portals);
						foreach( $node['trust']['portals'] as &$portal ){
							$portal = str_replace('_virustotal.','v.',$portal);
							if( !strpos($portal,'.') ){$portal = 'i.'.preg_replace('!^[_]*!','',$portal);}
						}
						unset($portal);
						/* END-Cantamos los portales */

						/* INI-Filtramos los portales del perfil */
						$node['trust']['portalsProfile'] = $node['trust']['portals'];
						if( !empty($excluded) ){
							$node['trust']['portalsProfile'] = array_diff($node['trust']['portals'],$excluded);
						}
						$node['trust']['portalsProfile'] = array_values($node['trust']['portalsProfile']);
						/* END-Filtramos los portales del perfil */
					}
					unset($node['pageTrust']);
					if( !empty($node['trust']) ){
						$node['pageTrust'] = $node['trust'];
						unset($node['trust']);
					}
					//if( isset($node['page-is']['final']) ){$traceOB['node-last'] = }
				}
				unset($node);
			}

			if( !empty($traceOB['gazelleTraceTrust']['portals']) ){
				foreach( $traceOB['gazelleTraceTrust']['portals'] as &$portal ){
					$portal = str_replace('_virustotal.','v.',$portal);
					if( !strpos($portal,'.') ){$portal = 'i.'.preg_replace('!^[_]*!','',$portal);}
				}
				unset($portal);
			}
			if( !empty($traceOB['gazelleTraceTrust']['portalsProfile']) ){
				foreach( $traceOB['gazelleTraceTrust']['portalsProfile'] as &$portal ){
					$portal = str_replace('_virustotal.','v.',$portal);
					if( !strpos($portal,'.') ){$portal = 'i.'.$portal;}
				}
				unset($portal);
			}
		}
	}


	trait _gazelle_trace_nodes{
		public $banned_portals = [
			 '_virustotal.dr-web'=>1
			,'_virustotal.fortinet'=>1
			,'_virustotal.netcraft'=>1
			,'_virustotal.sucuri-sitecheck'=>1
		];
		function _node_isClean($node = []){
			$return = [
				 'page.is.clean'      => true
				,'page.is.malicious'  => false
				,'page.is.malware'    => false
				,'page.is.phishing'   => false
				,'page.is.suspicious' => false
				,'page.is.attachment' => false
				,'page.is.attachmentExe' => false
				,'page.is.attachmentApk' => false
				,'page.is.checkingChromeExtension' => false
				,'portals' => []
			];

			if( !empty($node['pageCurrent']) ){
				if( strpos($node['pageCurrent'],'chrome-extension:') === 0 ){
					$return['page.is.checkingChromeExtension'] = true;
					$node['pageTrust']['_gazelle']['result'] = 'malware';
				}
			}

			if( !empty($node['pageHeader']['content-transfer-encoding'])
			 && !empty($node['pageHeader']['content-disposition'])
			 && strpos($node['pageHeader']['content-disposition'],'attachment') !== false
			){
				$return['page.is.attachment'] = true;
				if( strpos($node['pageHeader']['content-disposition'],'.exe') !== false ){
					/* Tiene pinta de virus */
					$return['page.is.attachmentExe'] = true;
					$node['pageTrust']['_gazelle']['result'] = 'malware';
				}
				if( strpos($node['pageHeader']['content-disposition'],'.apk') !== false ){
					/* Tiene pinta de app fraudulenta */
					$return['page.is.attachmentApk'] = true;
					$node['pageTrust']['_gazelle']['result'] = 'malware';
				}
			}

			if( !empty($node['pageHeader']['content-type'])
			 && in_array($node['pageHeader']['content-type'],['application/octet-stream','application/vnd.android.package-archive'])
			 && strpos($node['pageCurrent'],'.apk') !== false ){
				$return['page.is.attachmentApk'] = true;
			}

			if( isset($node['pageTrust']) ){foreach( $node['pageTrust'] as $portal=>$data ){
				if( isset($data['result']) ){
					$data['result'] = strtolower($data['result']);
					/* Estos son los portales individuales, como por ejemplo google */
					if( !$data['result'] || $data['result'] == 'clean site' ){continue;}
					if( $data['result'] == 'unwanted' ){$data['result'] = 'clean site';}

					$trace['page.is.clean'] = $return['page.is.clean'] = false;
					if( $data['result'] == 'malware' ){$trace['page.is.malware'] = $return['page.is.malware'] = true;}
					elseif( $data['result'] == 'phishing' ){$trace['page.is.phishing'] = $return['page.is.phishing'] = true;}
					elseif( $data['result'] && $data['result'] != 'clean site' ){echo 'TODO: en linea '.__LINE__.' fichero '.__FILE__;print_r($data);unset($node['pageTrust'][$portal]);continue;}
					$return['portals'][] = $portal;
					continue;
				}
//FIXME montar script para comprobación de errorDescription en $data
				if( isset($data['results']) ){foreach( $data['results'] as $subportal=>$subdata ){
					$id = $portal.'.'.$subportal;
					if( isset($this->banned_portals[$id]) ){continue;}

					$subdata['result'] = strtolower($subdata['result']);
					/* Estos son los meta-portales, como por ejemplo virustotal */
					if( in_array($subdata['result'],['','clean site','unrated site']) ){continue;}
					$trace['page.is.clean'] = $return['page.is.clean'] = false;
					if( $subdata['result'] == 'malicious site' ){$trace['page.is.malicious'] = $return['page.is.malicious'] = true;}
					if( $subdata['result'] == 'malware site' ){$trace['page.is.malware'] = $return['page.is.malware'] = true;}
					if( $subdata['result'] == 'phishing site' ){$trace['page.is.phishing'] = $return['page.is.phishing'] = true;}
					if( $subdata['result'] == 'suspicious site' ){$trace['page.is.suspicious'] = $return['page.is.suspicious'] = true;}
					$return['portals'][] = $id;
				}}
			}}

			return $return;
		}
		function _node_isResource($node = [],$debug = false){
			//FIXME: posiblemente descartar por longitud tb
			//FIXME: posiblemente hacerlo con stripos
			if( !empty($node['parentFrameId']) && $node['parentFrameId'] < 0 ){
				/* Main frame de chrome, no puede ser recurso */
				return false;
			}
			if( empty($node['pageContentType']) && !empty($node['pageHeader']['content-type']) ){
				$node['pageContentType'] = $node['pageHeader']['content-type'];
			}
			if( $debug ){
				var_dump( isset($node['pageContentType'],$node['pageCode']) );
			}
			if( isset($node['pageCurrent']) && substr($node['pageCurrent'],0,5) == 'data:' ){
				return true;
			}
			if( $node['pageCode'] == 304 && preg_match('!\.(css|js)$!',$node['pageCurrent']) ){
				return true;
			}
			if( $node['pageCode'] == 200 && preg_match('!\.(js)$!',$node['pageCurrent'])
			 && (strpos($node['pageContentType'],'text/html') !== false || empty($node['pageContentType'])) ){
				/* Caso especial para cuando los javascripts tienen cabeceras de mierda */
				return true;
			}
			if( !empty($node['pageHeader']['content-transfer-encoding'])
			 && !empty($node['pageHeader']['content-disposition'])
			 && strpos($node['pageHeader']['content-disposition'],'attachment') !== false ){
				/* Suele ser un puto fichero descargable */
				return false;
			}
			return isset($node['pageContentType'],$node['pageCode'])
				 && ( $node['pageCode'] != 301 && $node['pageCode'] != 302 )
				 && ( strpos($node['pageContentType'],'text/javascript') !== false
				      || strpos($node['pageContentType'],'text/css') !== false
				      || strpos($node['pageContentType'],'image/jpeg') !== false
				      || strpos($node['pageContentType'],'image/jpg') !== false
				      || strpos($node['pageContentType'],'image/gif') !== false
				      || strpos($node['pageContentType'],'image/png') !== false
				      || strpos($node['pageContentType'],'image/svg+xml') !== false
				      || strpos($node['pageContentType'],'image/webp') !== false
				      || strpos($node['pageContentType'],'application/javascript') !== false
				      || strpos($node['pageContentType'],'application/x-javascript') !== false
				      || strpos($node['pageContentType'],'application/font-woff') !== false
				      || strpos($node['pageContentType'],'application/x-font-woff') !== false
				      || strpos($node['pageContentType'],'application/octet-stream') !== false
				      || strpos($node['pageContentType'],'binary/octet-stream') !== false
				      || strpos($node['pageContentType'],'font/woff') !== false
				      || strpos($node['pageContentType'],'font/ttf') !== false
				      || strpos($node['pageContentType'],'font/opentype') !== false
				      || strpos($node['pageContentType'],'audio/mp3') !== false
				      || strpos($node['pageContentType'],'audio/ogg') !== false
				);
		}
	}

	/*************************************/
	/* Class: _gazelle_trace_count_cache */
	/*************************************/
	/* INI-mongo tables */
	$GLOBALS['api']['mongo']['tables']['gazelle.trace.count.cache'] = [
		 '_id'=>'INTEGER AUTOINCREMENT'
		,'cacheUser'      => 'TEXT'
		,'cacheDate'      => 'TEXT'
		,'cacheSignature' => 'TEXT'
		,'cacheValue'     => 'TEXT'
		,'z'              => 'TEXT'/* Datos extra del cron, 'z' para que vayan al final */
	];
	/* END-mongo tables */

	/* INI-mongo indexes */
	$GLOBALS['api']['mongo']['indexes']['gazelle.trace.count.cache'] = [
		 [ 'fields' => [ 'cacheSignature' => 1 ], 'props' => [ 'background' => true ] ]
		,[ 'fields' => [ 'cacheUser' => 1, 'cacheDate' => 1 ], 'props' => [ 'background' => true ] ]
	];
	/* END-mongo indexes */

	class _gazelle_trace_count_cache extends _mongo {
		public $table = 'gazelle.trace.count.cache';
		function validate( &$data = [], &$oldData = [] ) {
			if ( empty($data['cacheUser']) || empty($data['cacheDate']) || empty($data['cacheSignature']) || !isset($data['cacheValue']) || !is_numeric($data['cacheValue'])) { return [ 'errorDescription' => 'CACHE_ERROR', 'file' => __FILE__, 'line' => __LINE__ ]; }
			return $data;
		}

		function getCache( $params ) {
			if ( $row = $this->getSingle([ 'cacheSignature' => $this->_cacheSignature($params) ]) && isset($row['cacheValue']) ) { return $row['cacheValue']; }
			return false;
		}

		function setCache( $params, $value ) {
			$data = [
				 'cacheUser'      => $params['gazelleUser']
				,'cacheDate'      => $params['gazelleRequestDate']
				,'cacheSignature' => $this->_cacheSignature($params)
				,'cacheValue'     => $value
			];
			return $this->save($data);
		}

		function purgeCache( $user, $date ) {
			$clause = [ 'cacheDate' => $date ];
			if ( 'all' != $user ) { $clause['cacheUser'] = $user; }
			return $this->removeWhere($clause);
		}

		function _cacheSignature( $params ) {
			ksort($params);
			return md5(json_encode($params));
		}

	}
